{**********************************************************************
                Copyright (c) PilotLogic Software House

 Package pl_FFmpeg5
 This file is part of CodeTyphon Studio (https://www.pilotlogic.com/)

 ***** BEGIN LICENSE BLOCK *****
 * Version: LGPL-2.1 with link exception (Modified LGPL)
 *
 * The contents of this file are subject to the
 * GNU LIBRARY GENERAL PUBLIC LICENSE Version 2.1 (the "License")
 * with the following modification:
 *
 * As a special exception, the copyright holders of this library give you
 * permission to link this library with independent modules to produce an
 * executable, regardless of the license terms of these independent modules,
 * and to copy and distribute the resulting executable under terms of your choice,
 * provided that you also meet, for each linked independent module, the terms
 * and conditions of the license of that module. An independent module is a
 * module which is not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library, but
 * you are not obligated to do so. If you do not wish to do so, delete this
 * exception statement from your version.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * ***** END LICENSE BLOCK *****

***********************************************************************}

unit ffmpeg_utils;   

{$MODE objfpc}{$H+}

interface

uses libavformat, libavutil;

function PPtrIdx(P: PPAnsiChar; I: Integer): PAnsiChar; overload;
function PPtrIdx(P: PPByte; I: Integer): PByte; overload;
function PPtrIdx(P: PInteger; I: Integer): Integer; overload;
function PPtrIdx(P: PInt64; I: Integer): Int64; overload;

function PtrIdx(P: PSmallInt; I: Integer): PSmallInt; overload;
function PtrIdx(P: PSingle; I: Integer): PSingle; overload;
function PtrIdx(P: PDouble; I: Integer): PDouble; overload;

function PPtrIdx(P: PPAVStream; I: Integer): PAVStream; overload;
function PPtrIdx(P: PPAVDictionary; I: Integer): PAVDictionary; overload;

type
  av_intfloat32 = record
    case Integer of
      0: (i: Cardinal);
      1: (f: Single);
  end;

function av_int2float(i: Cardinal): Single;

implementation

function PPtrIdx(P: PPAnsiChar; I: Integer): PAnsiChar;
begin
  Inc(P, I);
  Result := P^;
end;

function PPtrIdx(P: PPByte; I: Integer): PByte;
begin
  Inc(P, I);
  Result := P^;
end;

function PPtrIdx(P: PInteger; I: Integer): Integer;
begin
  Inc(P, I);
  Result := P^;
end;

function PPtrIdx(P: PInt64; I: Integer): Int64;
begin
  Inc(P, I);
  Result := P^;
end;

function PtrIdx(P: PSmallInt; I: Integer): PSmallInt;
begin
  Result := P;
  Inc(Result, I);
end;

function PtrIdx(P: PSingle; I: Integer): PSingle;
begin
  Inc(P, I);
  Result := P;
end;

function PtrIdx(P: PDouble; I: Integer): PDouble;
begin
  Inc(P, I);
  Result := P;
end;

function PPtrIdx(P: PPAVStream; I: Integer): PAVStream;
begin
  Inc(P, I);
  Result := P^;
end;

function PPtrIdx(P: PPAVDictionary; I: Integer): PAVDictionary;
begin
  Inc(P, I);
  Result := P^;
end;

function av_int2float(i: Cardinal): Single;
var
  v: av_intfloat32;
begin
  v.i := i;
  Result := v.f;
end;

end.
