{**********************************************************************
                Copyright (c) PilotLogic Software House

 Package pl_FFmpeg5
 This file is part of CodeTyphon Studio (https://www.pilotlogic.com/)

 ***** BEGIN LICENSE BLOCK *****
 * Version: LGPL-2.1 with link exception (Modified LGPL)
 *
 * The contents of this file are subject to the
 * GNU LIBRARY GENERAL PUBLIC LICENSE Version 2.1 (the "License")
 * with the following modification:
 *
 * As a special exception, the copyright holders of this library give you
 * permission to link this library with independent modules to produce an
 * executable, regardless of the license terms of these independent modules,
 * and to copy and distribute the resulting executable under terms of your choice,
 * provided that you also meet, for each linked independent module, the terms
 * and conditions of the license of that module. An independent module is a
 * module which is not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library, but
 * you are not obligated to do so. If you do not wish to do so, delete this
 * exception statement from your version.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * ***** END LICENSE BLOCK *****

***********************************************************************}

Unit libavcodec;

{$MODE objfpc}{$H+}

Interface

Uses
  ctypes,
  Classes, dynlibs,
  ffmpeg_types, libavutil;

Const
{$IF defined(MSWINDOWS)}
   avcodecLibName = 'avcodec-59.dll';
{$ELSEIF defined(LINUX)}
   avcodecLibName = 'libavcodec.so.59';
{$ELSEIF defined(DARWIN)}
   avcodecLibName = 'libavcodec.59.dylib';
{$ELSE}
   avcodecLibName = 'libavcodec.so.59';
{$ENDIF}


Type
   pAVCodecID = ^AVCodecID;
   AVCodecID = (
      AV_CODEC_ID_NONE,
      AV_CODEC_ID_MPEG1VIDEO,
      AV_CODEC_ID_MPEG2VIDEO,
      AV_CODEC_ID_H261,
      AV_CODEC_ID_H263,
      AV_CODEC_ID_RV10,
      AV_CODEC_ID_RV20,
      AV_CODEC_ID_MJPEG,
      AV_CODEC_ID_MJPEGB,
      AV_CODEC_ID_LJPEG,
      AV_CODEC_ID_SP5X,
      AV_CODEC_ID_JPEGLS,
      AV_CODEC_ID_MPEG4,
      AV_CODEC_ID_RAWVIDEO,
      AV_CODEC_ID_MSMPEG4V1,
      AV_CODEC_ID_MSMPEG4V2,
      AV_CODEC_ID_MSMPEG4V3,
      AV_CODEC_ID_WMV1,
      AV_CODEC_ID_WMV2,
      AV_CODEC_ID_H263P,
      AV_CODEC_ID_H263I,
      AV_CODEC_ID_FLV1,
      AV_CODEC_ID_SVQ1,
      AV_CODEC_ID_SVQ3,
      AV_CODEC_ID_DVVIDEO,
      AV_CODEC_ID_HUFFYUV,
      AV_CODEC_ID_CYUV,
      AV_CODEC_ID_H264,
      AV_CODEC_ID_INDEO3,
      AV_CODEC_ID_VP3,
      AV_CODEC_ID_THEORA,
      AV_CODEC_ID_ASV1,
      AV_CODEC_ID_ASV2,
      AV_CODEC_ID_FFV1,
      AV_CODEC_ID_4XM,
      AV_CODEC_ID_VCR1,
      AV_CODEC_ID_CLJR,
      AV_CODEC_ID_MDEC,
      AV_CODEC_ID_ROQ,
      AV_CODEC_ID_INTERPLAY_VIDEO,
      AV_CODEC_ID_XAN_WC3,
      AV_CODEC_ID_XAN_WC4,
      AV_CODEC_ID_RPZA,
      AV_CODEC_ID_CINEPAK,
      AV_CODEC_ID_WS_VQA,
      AV_CODEC_ID_MSRLE,
      AV_CODEC_ID_MSVIDEO1,
      AV_CODEC_ID_IDCIN,
      AV_CODEC_ID_8BPS,
      AV_CODEC_ID_SMC,
      AV_CODEC_ID_FLIC,
      AV_CODEC_ID_TRUEMOTION1,
      AV_CODEC_ID_VMDVIDEO,
      AV_CODEC_ID_MSZH,
      AV_CODEC_ID_ZLIB,
      AV_CODEC_ID_QTRLE,
      AV_CODEC_ID_TSCC,
      AV_CODEC_ID_ULTI,
      AV_CODEC_ID_QDRAW,
      AV_CODEC_ID_VIXL,
      AV_CODEC_ID_QPEG,
      AV_CODEC_ID_PNG,
      AV_CODEC_ID_PPM,
      AV_CODEC_ID_PBM,
      AV_CODEC_ID_PGM,
      AV_CODEC_ID_PGMYUV,
      AV_CODEC_ID_PAM,
      AV_CODEC_ID_FFVHUFF,
      AV_CODEC_ID_RV30,
      AV_CODEC_ID_RV40,
      AV_CODEC_ID_VC1,
      AV_CODEC_ID_WMV3,
      AV_CODEC_ID_LOCO,
      AV_CODEC_ID_WNV1,
      AV_CODEC_ID_AASC,
      AV_CODEC_ID_INDEO2,
      AV_CODEC_ID_FRAPS,
      AV_CODEC_ID_TRUEMOTION2,
      AV_CODEC_ID_BMP,
      AV_CODEC_ID_CSCD,
      AV_CODEC_ID_MMVIDEO,
      AV_CODEC_ID_ZMBV,
      AV_CODEC_ID_AVS,
      AV_CODEC_ID_SMACKVIDEO,
      AV_CODEC_ID_NUV,
      AV_CODEC_ID_KMVC,
      AV_CODEC_ID_FLASHSV,
      AV_CODEC_ID_CAVS,
      AV_CODEC_ID_JPEG2000,
      AV_CODEC_ID_VMNC,
      AV_CODEC_ID_VP5,
      AV_CODEC_ID_VP6,
      AV_CODEC_ID_VP6F,
      AV_CODEC_ID_TARGA,
      AV_CODEC_ID_DSICINVIDEO,
      AV_CODEC_ID_TIERTEXSEQVIDEO,
      AV_CODEC_ID_TIFF,
      AV_CODEC_ID_GIF,
      AV_CODEC_ID_DXA,
      AV_CODEC_ID_DNXHD,
      AV_CODEC_ID_THP,
      AV_CODEC_ID_SGI,
      AV_CODEC_ID_C93,
      AV_CODEC_ID_BETHSOFTVID,
      AV_CODEC_ID_PTX,
      AV_CODEC_ID_TXD,
      AV_CODEC_ID_VP6A,
      AV_CODEC_ID_AMV,
      AV_CODEC_ID_VB,
      AV_CODEC_ID_PCX,
      AV_CODEC_ID_SUNRAST,
      AV_CODEC_ID_INDEO4,
      AV_CODEC_ID_INDEO5,
      AV_CODEC_ID_MIMIC,
      AV_CODEC_ID_RL2,
      AV_CODEC_ID_ESCAPE124,
      AV_CODEC_ID_DIRAC,
      AV_CODEC_ID_BFI,
      AV_CODEC_ID_CMV,
      AV_CODEC_ID_MOTIONPIXELS,
      AV_CODEC_ID_TGV,
      AV_CODEC_ID_TGQ,
      AV_CODEC_ID_TQI,
      AV_CODEC_ID_AURA,
      AV_CODEC_ID_AURA2,
      AV_CODEC_ID_V210X,
      AV_CODEC_ID_TMV,
      AV_CODEC_ID_V210,
      AV_CODEC_ID_DPX,
      AV_CODEC_ID_MAD,
      AV_CODEC_ID_FRWU,
      AV_CODEC_ID_FLASHSV2,
      AV_CODEC_ID_CDGRAPHICS,
      AV_CODEC_ID_R210,
      AV_CODEC_ID_ANM,
      AV_CODEC_ID_BINKVIDEO,
      AV_CODEC_ID_IFF_ILBM,
      AV_CODEC_ID_KGV1,
      AV_CODEC_ID_YOP,
      AV_CODEC_ID_VP8,
      AV_CODEC_ID_PICTOR,
      AV_CODEC_ID_ANSI,
      AV_CODEC_ID_A64_MULTI,
      AV_CODEC_ID_A64_MULTI5,
      AV_CODEC_ID_R10K,
      AV_CODEC_ID_MXPEG,
      AV_CODEC_ID_LAGARITH,
      AV_CODEC_ID_PRORES,
      AV_CODEC_ID_JV,
      AV_CODEC_ID_DFA,
      AV_CODEC_ID_WMV3IMAGE,
      AV_CODEC_ID_VC1IMAGE,
      AV_CODEC_ID_UTVIDEO,
      AV_CODEC_ID_BMV_VIDEO,
      AV_CODEC_ID_VBLE,
      AV_CODEC_ID_DXTORY,
      AV_CODEC_ID_V410,
      AV_CODEC_ID_XWD,
      AV_CODEC_ID_CDXL,
      AV_CODEC_ID_XBM,
      AV_CODEC_ID_ZEROCODEC,
      AV_CODEC_ID_MSS1,
      AV_CODEC_ID_MSA1,
      AV_CODEC_ID_TSCC2,
      AV_CODEC_ID_MTS2,
      AV_CODEC_ID_CLLC,
      AV_CODEC_ID_MSS2,
      AV_CODEC_ID_VP9,
      AV_CODEC_ID_AIC,
      AV_CODEC_ID_ESCAPE130,
      AV_CODEC_ID_G2M,
      AV_CODEC_ID_WEBP,
      AV_CODEC_ID_HNM4_VIDEO,
      AV_CODEC_ID_HEVC,
      AV_CODEC_ID_FIC,
      AV_CODEC_ID_ALIAS_PIX,
      AV_CODEC_ID_BRENDER_PIX,
      AV_CODEC_ID_PAF_VIDEO,
      AV_CODEC_ID_EXR,
      AV_CODEC_ID_VP7,
      AV_CODEC_ID_SANM,
      AV_CODEC_ID_SGIRLE,
      AV_CODEC_ID_MVC1,
      AV_CODEC_ID_MVC2,
      AV_CODEC_ID_HQX,
      AV_CODEC_ID_TDSC,
      AV_CODEC_ID_HQ_HQA,
      AV_CODEC_ID_HAP,
      AV_CODEC_ID_DDS,
      AV_CODEC_ID_DXV,
      AV_CODEC_ID_SCREENPRESSO,
      AV_CODEC_ID_RSCC,
      AV_CODEC_ID_AVS2,
      AV_CODEC_ID_Y41P = $8000,
      AV_CODEC_ID_AVRP,
      AV_CODEC_ID_012V,
      AV_CODEC_ID_AVUI,
      AV_CODEC_ID_AYUV,
      AV_CODEC_ID_TARGA_Y216,
      AV_CODEC_ID_V308,
      AV_CODEC_ID_V408,
      AV_CODEC_ID_YUV4,
      AV_CODEC_ID_AVRN,
      AV_CODEC_ID_CPIA,
      AV_CODEC_ID_XFACE,
      AV_CODEC_ID_SNOW,
      AV_CODEC_ID_SMVJPEG,
      AV_CODEC_ID_APNG,
      AV_CODEC_ID_DAALA,
      AV_CODEC_ID_CFHD,
      AV_CODEC_ID_TRUEMOTION2RT,
      AV_CODEC_ID_M101,
      AV_CODEC_ID_MAGICYUV,
      AV_CODEC_ID_SHEERVIDEO,
      AV_CODEC_ID_YLC,
      AV_CODEC_ID_PSD,
      AV_CODEC_ID_PIXLET,
      AV_CODEC_ID_SPEEDHQ,
      AV_CODEC_ID_FMVC,
      AV_CODEC_ID_SCPR,
      AV_CODEC_ID_CLEARVIDEO,
      AV_CODEC_ID_XPM,
      AV_CODEC_ID_AV1,
      AV_CODEC_ID_BITPACKED,
      AV_CODEC_ID_MSCC,
      AV_CODEC_ID_SRGC,
      AV_CODEC_ID_SVG,
      AV_CODEC_ID_GDV,
      AV_CODEC_ID_FITS,
      AV_CODEC_ID_IMM4,
      AV_CODEC_ID_PROSUMER,
      AV_CODEC_ID_MWSC,
      AV_CODEC_ID_WCMV,
      AV_CODEC_ID_RASC,
      AV_CODEC_ID_HYMT,
      AV_CODEC_ID_ARBC,
      AV_CODEC_ID_AGM,
      AV_CODEC_ID_LSCR,
      AV_CODEC_ID_VP4,
      AV_CODEC_ID_FIRST_AUDIO = $10000,
      AV_CODEC_ID_PCM_S16LE = $10000,
      AV_CODEC_ID_PCM_S16BE,
      AV_CODEC_ID_PCM_U16LE,
      AV_CODEC_ID_PCM_U16BE,
      AV_CODEC_ID_PCM_S8,
      AV_CODEC_ID_PCM_U8,
      AV_CODEC_ID_PCM_MULAW,
      AV_CODEC_ID_PCM_ALAW,
      AV_CODEC_ID_PCM_S32LE,
      AV_CODEC_ID_PCM_S32BE,
      AV_CODEC_ID_PCM_U32LE,
      AV_CODEC_ID_PCM_U32BE,
      AV_CODEC_ID_PCM_S24LE,
      AV_CODEC_ID_PCM_S24BE,
      AV_CODEC_ID_PCM_U24LE,
      AV_CODEC_ID_PCM_U24BE,
      AV_CODEC_ID_PCM_S24DAUD,
      AV_CODEC_ID_PCM_ZORK,
      AV_CODEC_ID_PCM_S16LE_PLANAR,
      AV_CODEC_ID_PCM_DVD,
      AV_CODEC_ID_PCM_F32BE,
      AV_CODEC_ID_PCM_F32LE,
      AV_CODEC_ID_PCM_F64BE,
      AV_CODEC_ID_PCM_F64LE,
      AV_CODEC_ID_PCM_BLURAY,
      AV_CODEC_ID_PCM_LXF,
      AV_CODEC_ID_S302M,
      AV_CODEC_ID_PCM_S8_PLANAR,
      AV_CODEC_ID_PCM_S24LE_PLANAR,
      AV_CODEC_ID_PCM_S32LE_PLANAR,
      AV_CODEC_ID_PCM_S16BE_PLANAR,
      AV_CODEC_ID_PCM_S64LE = $10800,
      AV_CODEC_ID_PCM_S64BE,
      AV_CODEC_ID_PCM_F16LE,
      AV_CODEC_ID_PCM_F24LE,
      AV_CODEC_ID_PCM_VIDC,
      AV_CODEC_ID_ADPCM_IMA_QT = $11000,
      AV_CODEC_ID_ADPCM_IMA_WAV,
      AV_CODEC_ID_ADPCM_IMA_DK3,
      AV_CODEC_ID_ADPCM_IMA_DK4,
      AV_CODEC_ID_ADPCM_IMA_WS,
      AV_CODEC_ID_ADPCM_IMA_SMJPEG,
      AV_CODEC_ID_ADPCM_MS,
      AV_CODEC_ID_ADPCM_4XM,
      AV_CODEC_ID_ADPCM_XA,
      AV_CODEC_ID_ADPCM_ADX,
      AV_CODEC_ID_ADPCM_EA,
      AV_CODEC_ID_ADPCM_G726,
      AV_CODEC_ID_ADPCM_CT,
      AV_CODEC_ID_ADPCM_SWF,
      AV_CODEC_ID_ADPCM_YAMAHA,
      AV_CODEC_ID_ADPCM_SBPRO_4,
      AV_CODEC_ID_ADPCM_SBPRO_3,
      AV_CODEC_ID_ADPCM_SBPRO_2,
      AV_CODEC_ID_ADPCM_THP,
      AV_CODEC_ID_ADPCM_IMA_AMV,
      AV_CODEC_ID_ADPCM_EA_R1,
      AV_CODEC_ID_ADPCM_EA_R3,
      AV_CODEC_ID_ADPCM_EA_R2,
      AV_CODEC_ID_ADPCM_IMA_EA_SEAD,
      AV_CODEC_ID_ADPCM_IMA_EA_EACS,
      AV_CODEC_ID_ADPCM_EA_XAS,
      AV_CODEC_ID_ADPCM_EA_MAXIS_XA,
      AV_CODEC_ID_ADPCM_IMA_ISS,
      AV_CODEC_ID_ADPCM_G722,
      AV_CODEC_ID_ADPCM_IMA_APC,
      AV_CODEC_ID_ADPCM_VIMA,
      AV_CODEC_ID_ADPCM_AFC = $11800,
      AV_CODEC_ID_ADPCM_IMA_OKI,
      AV_CODEC_ID_ADPCM_DTK,
      AV_CODEC_ID_ADPCM_IMA_RAD,
      AV_CODEC_ID_ADPCM_G726LE,
      AV_CODEC_ID_ADPCM_THP_LE,
      AV_CODEC_ID_ADPCM_PSX,
      AV_CODEC_ID_ADPCM_AICA,
      AV_CODEC_ID_ADPCM_IMA_DAT4,
      AV_CODEC_ID_ADPCM_MTAF,
      AV_CODEC_ID_ADPCM_AGM,
      AV_CODEC_ID_AMR_NB = $12000,
      AV_CODEC_ID_AMR_WB,
      AV_CODEC_ID_RA_144 = $13000,
      AV_CODEC_ID_RA_288,
      AV_CODEC_ID_ROQ_DPCM = $14000,
      AV_CODEC_ID_INTERPLAY_DPCM,
      AV_CODEC_ID_XAN_DPCM,
      AV_CODEC_ID_SOL_DPCM,
      AV_CODEC_ID_SDX2_DPCM = $14800,
      AV_CODEC_ID_GREMLIN_DPCM,
      AV_CODEC_ID_MP2 = $15000,
      AV_CODEC_ID_MP3,
      AV_CODEC_ID_AAC,
      AV_CODEC_ID_AC3,
      AV_CODEC_ID_DTS,
      AV_CODEC_ID_VORBIS,
      AV_CODEC_ID_DVAUDIO,
      AV_CODEC_ID_WMAV1,
      AV_CODEC_ID_WMAV2,
      AV_CODEC_ID_MACE3,
      AV_CODEC_ID_MACE6,
      AV_CODEC_ID_VMDAUDIO,
      AV_CODEC_ID_FLAC,
      AV_CODEC_ID_MP3ADU,
      AV_CODEC_ID_MP3ON4,
      AV_CODEC_ID_SHORTEN,
      AV_CODEC_ID_ALAC,
      AV_CODEC_ID_WESTWOOD_SND1,
      AV_CODEC_ID_GSM,
      AV_CODEC_ID_QDM2,
      AV_CODEC_ID_COOK,
      AV_CODEC_ID_TRUESPEECH,
      AV_CODEC_ID_TTA,
      AV_CODEC_ID_SMACKAUDIO,
      AV_CODEC_ID_QCELP,
      AV_CODEC_ID_WAVPACK,
      AV_CODEC_ID_DSICINAUDIO,
      AV_CODEC_ID_IMC,
      AV_CODEC_ID_MUSEPACK7,
      AV_CODEC_ID_MLP,
      AV_CODEC_ID_GSM_MS,
      AV_CODEC_ID_ATRAC3,
      AV_CODEC_ID_APE,
      AV_CODEC_ID_NELLYMOSER,
      AV_CODEC_ID_MUSEPACK8,
      AV_CODEC_ID_SPEEX,
      AV_CODEC_ID_WMAVOICE,
      AV_CODEC_ID_WMAPRO,
      AV_CODEC_ID_WMALOSSLESS,
      AV_CODEC_ID_ATRAC3P,
      AV_CODEC_ID_EAC3,
      AV_CODEC_ID_SIPR,
      AV_CODEC_ID_MP1,
      AV_CODEC_ID_TWINVQ,
      AV_CODEC_ID_TRUEHD,
      AV_CODEC_ID_MP4ALS,
      AV_CODEC_ID_ATRAC1,
      AV_CODEC_ID_BINKAUDIO_RDFT,
      AV_CODEC_ID_BINKAUDIO_DCT,
      AV_CODEC_ID_AAC_LATM,
      AV_CODEC_ID_QDMC,
      AV_CODEC_ID_CELT,
      AV_CODEC_ID_G723_1,
      AV_CODEC_ID_G729,
      AV_CODEC_ID_8SVX_EXP,
      AV_CODEC_ID_8SVX_FIB,
      AV_CODEC_ID_BMV_AUDIO,
      AV_CODEC_ID_RALF,
      AV_CODEC_ID_IAC,
      AV_CODEC_ID_ILBC,
      AV_CODEC_ID_OPUS,
      AV_CODEC_ID_COMFORT_NOISE,
      AV_CODEC_ID_TAK,
      AV_CODEC_ID_METASOUND,
      AV_CODEC_ID_PAF_AUDIO,
      AV_CODEC_ID_ON2AVC,
      AV_CODEC_ID_DSS_SP,
      AV_CODEC_ID_CODEC2,
      AV_CODEC_ID_FFWAVESYNTH = $15800,
      AV_CODEC_ID_SONIC,
      AV_CODEC_ID_SONIC_LS,
      AV_CODEC_ID_EVRC,
      AV_CODEC_ID_SMV,
      AV_CODEC_ID_DSD_LSBF,
      AV_CODEC_ID_DSD_MSBF,
      AV_CODEC_ID_DSD_LSBF_PLANAR,
      AV_CODEC_ID_DSD_MSBF_PLANAR,
      AV_CODEC_ID_4GV,
      AV_CODEC_ID_INTERPLAY_ACM,
      AV_CODEC_ID_XMA1,
      AV_CODEC_ID_XMA2,
      AV_CODEC_ID_DST,
      AV_CODEC_ID_ATRAC3AL,
      AV_CODEC_ID_ATRAC3PAL,
      AV_CODEC_ID_DOLBY_E,
      AV_CODEC_ID_APTX,
      AV_CODEC_ID_APTX_HD,
      AV_CODEC_ID_SBC,
      AV_CODEC_ID_ATRAC9,
      AV_CODEC_ID_HCOM,
      AV_CODEC_ID_FIRST_SUBTITLE = $17000,
      AV_CODEC_ID_DVD_SUBTITLE = $17000,
      AV_CODEC_ID_DVB_SUBTITLE,
      AV_CODEC_ID_TEXT,
      AV_CODEC_ID_XSUB,
      AV_CODEC_ID_SSA,
      AV_CODEC_ID_MOV_TEXT,
      AV_CODEC_ID_HDMV_PGS_SUBTITLE,
      AV_CODEC_ID_DVB_TELETEXT,
      AV_CODEC_ID_SRT,
      AV_CODEC_ID_MICRODVD = $17800,
      AV_CODEC_ID_EIA_608,
      AV_CODEC_ID_JACOSUB,
      AV_CODEC_ID_SAMI,
      AV_CODEC_ID_REALTEXT,
      AV_CODEC_ID_STL,
      AV_CODEC_ID_SUBVIEWER1,
      AV_CODEC_ID_SUBVIEWER,
      AV_CODEC_ID_SUBRIP,
      AV_CODEC_ID_WEBVTT,
      AV_CODEC_ID_MPL2,
      AV_CODEC_ID_VPLAYER,
      AV_CODEC_ID_PJS,
      AV_CODEC_ID_ASS,
      AV_CODEC_ID_HDMV_TEXT_SUBTITLE,
      AV_CODEC_ID_TTML,
      AV_CODEC_ID_ARIB_CAPTION,
      AV_CODEC_ID_FIRST_UNKNOWN = $18000,
      AV_CODEC_ID_TTF = $18000,
      AV_CODEC_ID_SCTE_35,
      AV_CODEC_ID_BINTEXT = $18800,
      AV_CODEC_ID_XBIN,
      AV_CODEC_ID_IDF,
      AV_CODEC_ID_OTF,
      AV_CODEC_ID_SMPTE_KLV,
      AV_CODEC_ID_DVD_NAV,
      AV_CODEC_ID_TIMED_ID3,
      AV_CODEC_ID_BIN_DATA,
      AV_CODEC_ID_MPEG2TS = $20000,
      AV_CODEC_ID_MPEG4SYSTEMS = $20001,
      AV_CODEC_ID_FFMETADATA = $21000,
      AV_CODEC_ID_WRAPPED_AVFRAME = $21001
      );
   TAVCodecID = AVCodecID;

Const
   AV_CODEC_ID_IFF_BYTERUN1: AVCodecID = AV_CODEC_ID_IFF_ILBM;
   AV_CODEC_ID_H265: AVCodecID = AV_CODEC_ID_HEVC;
   AV_CODEC_HW_CONFIG_METHOD_HW_DEVICE_CTX = $01;
   AV_CODEC_HW_CONFIG_METHOD_HW_FRAMES_CTX = $02;
   AV_CODEC_HW_CONFIG_METHOD_INTERNAL = $04;
   AV_CODEC_HW_CONFIG_METHOD_AD_HOC = $08;
   AV_CODEC_PROP_INTRA_ONLY = (1 Shl 0);
   AV_CODEC_PROP_LOSSY = (1 Shl 1);
   AV_CODEC_PROP_LOSSLESS = (1 Shl 2);
   AV_CODEC_PROP_REORDER = (1 Shl 3);
   AV_CODEC_PROP_BITMAP_SUB = (1 Shl 16);
   AV_CODEC_PROP_TEXT_SUB = (1 Shl 17);
   AV_INPUT_BUFFER_PADDING_SIZE = 64;
   AV_INPUT_BUFFER_MIN_SIZE = 16384;
   AV_CODEC_FLAG_UNALIGNED = (1 Shl 0);
   AV_CODEC_FLAG_QSCALE = (1 Shl 1);
   AV_CODEC_FLAG_4MV = (1 Shl 2);
   AV_CODEC_FLAG_OUTPUT_CORRUPT = (1 Shl 3);
   AV_CODEC_FLAG_QPEL = (1 Shl 4);
   AV_CODEC_FLAG_DROPCHANGED = (1 Shl 5);
   AV_CODEC_FLAG_PASS1 = (1 Shl 9);
   AV_CODEC_FLAG_PASS2 = (1 Shl 10);
   AV_CODEC_FLAG_LOOP_FILTER = (1 Shl 11);
   AV_CODEC_FLAG_GRAY = (1 Shl 13);
   AV_CODEC_FLAG_PSNR = (1 Shl 15);
   AV_CODEC_FLAG_TRUNCATED = (1 Shl 16);
   AV_CODEC_FLAG_INTERLACED_DCT = (1 Shl 18);
   AV_CODEC_FLAG_LOW_DELAY = (1 Shl 19);
   AV_CODEC_FLAG_GLOBAL_HEADER = (1 Shl 22);
   AV_CODEC_FLAG_BITEXACT = (1 Shl 23);
   AV_CODEC_FLAG_AC_PRED = (1 Shl 24);
   AV_CODEC_FLAG_INTERLACED_ME = (1 Shl 29);
   AV_CODEC_FLAG_CLOSED_GOP = (1 Shl 31);
   AV_CODEC_FLAG2_FAST = (1 Shl 0);
   AV_CODEC_FLAG2_NO_OUTPUT = (1 Shl 2);
   AV_CODEC_FLAG2_LOCAL_HEADER = (1 Shl 3);
   AV_CODEC_FLAG2_DROP_FRAME_TIMECODE = (1 Shl 13);
   AV_CODEC_FLAG2_CHUNKS = (1 Shl 15);
   AV_CODEC_FLAG2_IGNORE_CROP = (1 Shl 16);
   AV_CODEC_FLAG2_SHOW_ALL = (1 Shl 22);
   AV_CODEC_FLAG2_EXPORT_MVS = (1 Shl 28);
   AV_CODEC_FLAG2_SKIP_MANUAL = (1 Shl 29);
   AV_CODEC_FLAG2_RO_FLUSH_NOOP = (1 Shl 30);
   AV_CODEC_CAP_DRAW_HORIZ_BAND = (1 Shl 0);
   AV_CODEC_CAP_DR1 = (1 Shl 1);
   AV_CODEC_CAP_TRUNCATED = (1 Shl 3);
   AV_CODEC_CAP_DELAY = (1 Shl 5);
   AV_CODEC_CAP_SMALL_LAST_FRAME = (1 Shl 6);
   AV_CODEC_CAP_SUBFRAMES = (1 Shl 8);
   AV_CODEC_CAP_EXPERIMENTAL = (1 Shl 9);
   AV_CODEC_CAP_CHANNEL_CONF = (1 Shl 10);
   AV_CODEC_CAP_FRAME_THREADS = (1 Shl 12);
   AV_CODEC_CAP_SLICE_THREADS = (1 Shl 13);
   AV_CODEC_CAP_PARAM_CHANGE = (1 Shl 14);
   AV_CODEC_CAP_AUTO_THREADS = (1 Shl 15);
   AV_CODEC_CAP_VARIABLE_FRAME_SIZE = (1 Shl 16);
   AV_CODEC_CAP_AVOID_PROBING = (1 Shl 17);
   AV_CODEC_CAP_INTRA_ONLY = $40000000;
   AV_CODEC_CAP_LOSSLESS = $80000000;
   AV_CODEC_CAP_HARDWARE = (1 Shl 18);
   AV_CODEC_CAP_HYBRID = (1 Shl 19);
   AV_CODEC_CAP_ENCODER_REORDERED_OPAQUE = (1 Shl 20);
   AV_HWACCEL_CODEC_CAP_EXPERIMENTAL = $0200;
   AV_HWACCEL_FLAG_IGNORE_LEVEL = (1 Shl 0);
   AV_HWACCEL_FLAG_ALLOW_HIGH_DEPTH = (1 Shl 1);
   AV_HWACCEL_FLAG_ALLOW_PROFILE_MISMATCH = (1 Shl 2);

Type
   AVProfile = Record
      profile: int;
      name: pAnsiChar;
   End;
   pAVProfile = ^AVProfile;

   pAVCodecDescriptor = ^AVCodecDescriptor;
   AVCodecDescriptor = Record
      id: AVCodecID;
      _type: AVMediaType;
      name: pAnsiChar;
      long_name: pAnsiChar;
      props: int;
      mime_types: PPAnsiChar;
      profiles: pAVProfile;
   End;

   pAVCodecHWConfig = ^AVCodecHWConfig;
   AVCodecHWConfig = Record
      pix_fmt: AVPixelFormat;
      methods: int;
      device_type: AVHWDeviceType;
   End;

   AVDiscard = (
      AVDISCARD_NONE = -16,
      AVDISCARD_DEFAULT = 0,
      AVDISCARD_NONREF = 8,
      AVDISCARD_BIDIR = 16,
      AVDISCARD_NONINTRA = 24,
      AVDISCARD_NONKEY = 32,
      AVDISCARD_ALL = 48
      );

   AVAudioServiceType = (
      AV_AUDIO_SERVICE_TYPE_MAIN = 0,
      AV_AUDIO_SERVICE_TYPE_EFFECTS = 1,
      AV_AUDIO_SERVICE_TYPE_VISUALLY_IMPAIRED = 2,
      AV_AUDIO_SERVICE_TYPE_HEARING_IMPAIRED = 3,
      AV_AUDIO_SERVICE_TYPE_DIALOGUE = 4,
      AV_AUDIO_SERVICE_TYPE_COMMENTARY = 5,
      AV_AUDIO_SERVICE_TYPE_EMERGENCY = 6,
      AV_AUDIO_SERVICE_TYPE_VOICE_OVER = 7,
      AV_AUDIO_SERVICE_TYPE_KARAOKE = 8,
      AV_AUDIO_SERVICE_TYPE_NB
      );

   RcOverride = Record
      start_frame: int;
      end_frame: int;
      qscale: int;
      quality_factor: float;
   End;

   pRcOverride = ^RcOverride;
   AVPanScan = Record
      id: int;
      width: int;
      height: int;
      position: Array[0..2, 0..1] Of int16_t;
   End;

   pAVCPBProperties = ^AVCPBProperties;
   AVCPBProperties = Record
      max_bitrate: int64_t;
      min_bitrate: int64_t;
      avg_bitrate: int64_t;
      buffer_size: int;
      vbv_delay: uint64_t;
   End;

Const
   AV_GET_BUFFER_FLAG_REF = (1 Shl 0);
   AV_PKT_FLAG_KEY = $0001;
   AV_PKT_FLAG_CORRUPT = $0002;
   AV_PKT_FLAG_DISCARD = $0004;
   AV_PKT_FLAG_TRUSTED = $0008;
   AV_PKT_FLAG_DISPOSABLE = $0010;
   FF_COMPRESSION_DEFAULT = -1;
   FF_PRED_LEFT = 0;
   FF_PRED_PLANE = 1;
   FF_PRED_MEDIAN = 2;
   FF_CMP_SAD = 0;
   FF_CMP_SSE = 1;
   FF_CMP_SATD = 2;
   FF_CMP_DCT = 3;
   FF_CMP_PSNR = 4;
   FF_CMP_BIT = 5;
   FF_CMP_RD = 6;
   FF_CMP_ZERO = 7;
   FF_CMP_VSAD = 8;
   FF_CMP_VSSE = 9;
   FF_CMP_NSSE = 10;
   FF_CMP_W53 = 11;
   FF_CMP_W97 = 12;
   FF_CMP_DCTMAX = 13;
   FF_CMP_DCT264 = 14;
   FF_CMP_MEDIAN_SAD = 15;
   FF_CMP_CHROMA = 256;
   SLICE_FLAG_CODED_ORDER = $0001;
   SLICE_FLAG_ALLOW_FIELD = $0002;
   SLICE_FLAG_ALLOW_PLANE = $0004;
   FF_MB_DECISION_SIMPLE = 0;
   FF_MB_DECISION_BITS = 1;
   FF_MB_DECISION_RD = 2;
   FF_CODER_TYPE_VLC = 0;
   FF_CODER_TYPE_AC = 1;
   FF_CODER_TYPE_RAW = 2;
   FF_CODER_TYPE_RLE = 3;
   FF_BUG_AUTODETECT = 1;
   FF_BUG_XVID_ILACE = 4;
   FF_BUG_UMP4 = 8;
   FF_BUG_NO_PADDING = 16;
   FF_BUG_AMV = 32;
   FF_BUG_QPEL_CHROMA = 64;
   FF_BUG_STD_QPEL = 128;
   FF_BUG_QPEL_CHROMA2 = 256;
   FF_BUG_DIRECT_BLOCKSIZE = 512;
   FF_BUG_EDGE = 1024;
   FF_BUG_HPEL_CHROMA = 2048;
   FF_BUG_DC_CLIP = 4096;
   FF_BUG_MS = 8192;
   FF_BUG_TRUNCATED = 16384;
   FF_BUG_IEDGE = 32768;
   FF_COMPLIANCE_VERY_STRICT = 2;
   FF_COMPLIANCE_STRICT = 1;
   FF_COMPLIANCE_NORMAL = 0;
   FF_COMPLIANCE_UNOFFICIAL = -1;
   FF_COMPLIANCE_EXPERIMENTAL = -2;
   FF_EC_GUESS_MVS = 1;
   FF_EC_DEBLOCK = 2;
   FF_EC_FAVOR_INTER = 256;
   FF_DEBUG_PICT_INFO = 1;
   FF_DEBUG_RC = 2;
   FF_DEBUG_BITSTREAM = 4;
   FF_DEBUG_MB_TYPE = 8;
   FF_DEBUG_QP = 16;
   FF_DEBUG_MV = 32;
   FF_DEBUG_DCT_COEFF = $00000040;
   FF_DEBUG_SKIP = $00000080;
   FF_DEBUG_STARTCODE = $00000100;
   FF_DEBUG_ER = $00000400;
   FF_DEBUG_MMCO = $00000800;
   FF_DEBUG_BUGS = $00001000;
   FF_DEBUG_VIS_QP = $00002000;
   FF_DEBUG_VIS_MB_TYPE = $00004000;
   FF_DEBUG_BUFFERS = $00008000;
   FF_DEBUG_THREADS = $00010000;
   FF_DEBUG_GREEN_MD = $00800000;
   FF_DEBUG_NOMC = $01000000;
   FF_DEBUG_VIS_MV_P_FOR = $00000001;
   FF_DEBUG_VIS_MV_B_FOR = $00000002;
   FF_DEBUG_VIS_MV_B_BACK = $00000004;
   AV_EF_CRCCHECK = (1 Shl 0);
   AV_EF_BITSTREAM = (1 Shl 1);
   AV_EF_BUFFER = (1 Shl 2);
   AV_EF_EXPLODE = (1 Shl 3);
   AV_EF_IGNORE_ERR = (1 Shl 15);
   AV_EF_CAREFUL = (1 Shl 16);
   AV_EF_COMPLIANT = (1 Shl 17);
   AV_EF_AGGRESSIVE = (1 Shl 18);
   FF_DCT_AUTO = 0;
   FF_DCT_FASTINT = 1;
   FF_DCT_INT = 2;
   FF_DCT_MMX = 3;
   FF_DCT_ALTIVEC = 5;
   FF_DCT_FAAN = 6;
   FF_IDCT_AUTO = 0;
   FF_IDCT_INT = 1;
   FF_IDCT_SIMPLE = 2;
   FF_IDCT_SIMPLEMMX = 3;
   FF_IDCT_ARM = 7;
   FF_IDCT_ALTIVEC = 8;
   FF_IDCT_SIMPLEARM = 10;
   FF_IDCT_XVID = 14;
   FF_IDCT_SIMPLEARMV5TE = 16;
   FF_IDCT_SIMPLEARMV6 = 17;
   FF_IDCT_FAAN = 20;
   FF_IDCT_SIMPLENEON = 22;
   FF_IDCT_NONE = 24;
   FF_IDCT_SIMPLEAUTO = 128;
   FF_THREAD_FRAME = 1;
   FF_THREAD_SLICE = 2;
   FF_PROFILE_UNKNOWN = -99;
   FF_PROFILE_RESERVED = -100;
   FF_PROFILE_AAC_MAIN = 0;
   FF_PROFILE_AAC_LOW = 1;
   FF_PROFILE_AAC_SSR = 2;
   FF_PROFILE_AAC_LTP = 3;
   FF_PROFILE_AAC_HE = 4;
   FF_PROFILE_AAC_HE_V2 = 28;
   FF_PROFILE_AAC_LD = 22;
   FF_PROFILE_AAC_ELD = 38;
   FF_PROFILE_MPEG2_AAC_LOW = 128;
   FF_PROFILE_MPEG2_AAC_HE = 131;
   FF_PROFILE_DNXHD = 0;
   FF_PROFILE_DNXHR_LB = 1;
   FF_PROFILE_DNXHR_SQ = 2;
   FF_PROFILE_DNXHR_HQ = 3;
   FF_PROFILE_DNXHR_HQX = 4;
   FF_PROFILE_DNXHR_444 = 5;
   FF_PROFILE_DTS = 20;
   FF_PROFILE_DTS_ES = 30;
   FF_PROFILE_DTS_96_24 = 40;
   FF_PROFILE_DTS_HD_HRA = 50;
   FF_PROFILE_DTS_HD_MA = 60;
   FF_PROFILE_DTS_EXPRESS = 70;
   FF_PROFILE_MPEG2_422 = 0;
   FF_PROFILE_MPEG2_HIGH = 1;
   FF_PROFILE_MPEG2_SS = 2;
   FF_PROFILE_MPEG2_SNR_SCALABLE = 3;
   FF_PROFILE_MPEG2_MAIN = 4;
   FF_PROFILE_MPEG2_SIMPLE = 5;
   FF_PROFILE_H264_CONSTRAINED = (1 Shl 9);
   FF_PROFILE_H264_INTRA = (1 Shl 11);
   FF_PROFILE_H264_BASELINE = 66;
   FF_PROFILE_H264_CONSTRAINED_BASELINE = (66 Or FF_PROFILE_H264_CONSTRAINED);
   FF_PROFILE_H264_MAIN = 77;
   FF_PROFILE_H264_EXTENDED = 88;
   FF_PROFILE_H264_HIGH = 100;
   FF_PROFILE_H264_HIGH_10 = 110;
   FF_PROFILE_H264_HIGH_10_INTRA = (110 Or FF_PROFILE_H264_INTRA);
   FF_PROFILE_H264_MULTIVIEW_HIGH = 118;
   FF_PROFILE_H264_HIGH_422 = 122;
   FF_PROFILE_H264_HIGH_422_INTRA = (122 Or FF_PROFILE_H264_INTRA);
   FF_PROFILE_H264_STEREO_HIGH = 128;
   FF_PROFILE_H264_HIGH_444 = 144;
   FF_PROFILE_H264_HIGH_444_PREDICTIVE = 244;
   FF_PROFILE_H264_HIGH_444_INTRA = (244 Or FF_PROFILE_H264_INTRA);
   FF_PROFILE_H264_CAVLC_444 = 44;
   FF_PROFILE_VC1_SIMPLE = 0;
   FF_PROFILE_VC1_MAIN = 1;
   FF_PROFILE_VC1_COMPLEX = 2;
   FF_PROFILE_VC1_ADVANCED = 3;
   FF_PROFILE_MPEG4_SIMPLE = 0;
   FF_PROFILE_MPEG4_SIMPLE_SCALABLE = 1;
   FF_PROFILE_MPEG4_CORE = 2;
   FF_PROFILE_MPEG4_MAIN = 3;
   FF_PROFILE_MPEG4_N_BIT = 4;
   FF_PROFILE_MPEG4_SCALABLE_TEXTURE = 5;
   FF_PROFILE_MPEG4_SIMPLE_FACE_ANIMATION = 6;
   FF_PROFILE_MPEG4_BASIC_ANIMATED_TEXTURE = 7;
   FF_PROFILE_MPEG4_HYBRID = 8;
   FF_PROFILE_MPEG4_ADVANCED_REAL_TIME = 9;
   FF_PROFILE_MPEG4_CORE_SCALABLE = 10;
   FF_PROFILE_MPEG4_ADVANCED_CODING = 11;
   FF_PROFILE_MPEG4_ADVANCED_CORE = 12;
   FF_PROFILE_MPEG4_ADVANCED_SCALABLE_TEXTURE = 13;
   FF_PROFILE_MPEG4_SIMPLE_STUDIO = 14;
   FF_PROFILE_MPEG4_ADVANCED_SIMPLE = 15;
   FF_PROFILE_JPEG2000_CSTREAM_RESTRICTION_0 = 1;
   FF_PROFILE_JPEG2000_CSTREAM_RESTRICTION_1 = 2;
   FF_PROFILE_JPEG2000_CSTREAM_NO_RESTRICTION = 32768;
   FF_PROFILE_JPEG2000_DCINEMA_2K = 3;
   FF_PROFILE_JPEG2000_DCINEMA_4K = 4;
   FF_PROFILE_VP9_0 = 0;
   FF_PROFILE_VP9_1 = 1;
   FF_PROFILE_VP9_2 = 2;
   FF_PROFILE_VP9_3 = 3;
   FF_PROFILE_HEVC_MAIN = 1;
   FF_PROFILE_HEVC_MAIN_10 = 2;
   FF_PROFILE_HEVC_MAIN_STILL_PICTURE = 3;
   FF_PROFILE_HEVC_REXT = 4;
   FF_PROFILE_AV1_MAIN = 0;
   FF_PROFILE_AV1_HIGH = 1;
   FF_PROFILE_AV1_PROFESSIONAL = 2;
   FF_PROFILE_MJPEG_HUFFMAN_BASELINE_DCT = $C0;
   FF_PROFILE_MJPEG_HUFFMAN_EXTENDED_SEQUENTIAL_DCT = $C1;
   FF_PROFILE_MJPEG_HUFFMAN_PROGRESSIVE_DCT = $C2;
   FF_PROFILE_MJPEG_HUFFMAN_LOSSLESS = $C3;
   FF_PROFILE_MJPEG_JPEG_LS = $F7;
   FF_PROFILE_SBC_MSBC = 1;
   FF_PROFILE_PRORES_PROXY = 0;
   FF_PROFILE_PRORES_LT = 1;
   FF_PROFILE_PRORES_STANDARD = 2;
   FF_PROFILE_PRORES_HQ = 3;
   FF_PROFILE_PRORES_4444 = 4;
   FF_PROFILE_PRORES_XQ = 5;
   FF_PROFILE_ARIB_PROFILE_A = 0;
   FF_PROFILE_ARIB_PROFILE_C = 1;
   FF_LEVEL_UNKNOWN = -99;
   FF_SUB_CHARENC_MODE_DO_NOTHING = -1;
   FF_SUB_CHARENC_MODE_AUTOMATIC = 0;
   FF_SUB_CHARENC_MODE_PRE_DECODER = 1;
   FF_SUB_CHARENC_MODE_IGNORE = 2;
   FF_CODEC_PROPERTY_LOSSLESS = $00000001;
   FF_CODEC_PROPERTY_CLOSED_CAPTIONS = $00000002;
   FF_SUB_TEXT_FMT_ASS = 0;
   FF_SUB_TEXT_FMT_ASS_WITH_TIMINGS = 1;
   AV_SUBTITLE_FLAG_FORCED = $00000001;

Type
   AVPacketSideDataType = (
      AV_PKT_DATA_PALETTE,
      AV_PKT_DATA_NEW_EXTRADATA,
      AV_PKT_DATA_PARAM_CHANGE,
      AV_PKT_DATA_H263_MB_INFO,
      AV_PKT_DATA_REPLAYGAIN,
      AV_PKT_DATA_DISPLAYMATRIX,
      AV_PKT_DATA_STEREO3D,
      AV_PKT_DATA_AUDIO_SERVICE_TYPE,
      AV_PKT_DATA_QUALITY_STATS,
      AV_PKT_DATA_FALLBACK_TRACK,
      AV_PKT_DATA_CPB_PROPERTIES,
      AV_PKT_DATA_SKIP_SAMPLES,
      AV_PKT_DATA_JP_DUALMONO,
      AV_PKT_DATA_STRINGS_METADATA,
      AV_PKT_DATA_SUBTITLE_POSITION,
      AV_PKT_DATA_MATROSKA_BLOCKADDITIONAL,
      AV_PKT_DATA_WEBVTT_IDENTIFIER,
      AV_PKT_DATA_WEBVTT_SETTINGS,
      AV_PKT_DATA_METADATA_UPDATE,
      AV_PKT_DATA_MPEGTS_STREAM_ID,
      AV_PKT_DATA_MASTERING_DISPLAY_METADATA,
      AV_PKT_DATA_SPHERICAL,
      AV_PKT_DATA_CONTENT_LIGHT_LEVEL,
      AV_PKT_DATA_A53_CC,
      AV_PKT_DATA_ENCRYPTION_INIT_INFO,
      AV_PKT_DATA_ENCRYPTION_INFO,
      AV_PKT_DATA_AFD,
      AV_PKT_DATA_NB);

   AVPacketSideData = Record
      data: puint8_t;
      size: int;
      _type: AVPacketSideDataType;
   End;
   pAVPacketSideData = ^AVPacketSideData;
                     
   ppAVPacket = ^pAVPacket;
   pAVPacket = ^AVPacket;
   AVPacket = Record
      buf: pAVBufferRef;
      pts: int64_t;
      dts: int64_t;
      data: puint8_t;
      size: int;
      stream_index: int;
      flags: int;
      side_data: pAVPacketSideData;
      side_data_elems: int;
      duration: int64_t;
      pos: int64_t;
      convergence_duration: int64_t
   End;      
   TAVPacket = AVPacket;

   AVSideDataParamChangeFlags = (
      AV_SIDE_DATA_PARAM_CHANGE_CHANNEL_COUNT = $0001,
      AV_SIDE_DATA_PARAM_CHANGE_CHANNEL_LAYOUT = $0002,
      AV_SIDE_DATA_PARAM_CHANGE_SAMPLE_RATE = $0004,
      AV_SIDE_DATA_PARAM_CHANGE_DIMENSIONS = $0008
      );

   AVCodecInternal = Record
   End;
   pAVCodecInternal = ^AVCodecInternal;

   AVFieldOrder = (
      AV_FIELD_UNKNOWN, AV_FIELD_PROGRESSIVE, AV_FIELD_TT,
      AV_FIELD_BB,
      AV_FIELD_TB,
      AV_FIELD_BT
      );

   AVCodecDefault = Record
   End;

   pAVCodec = ^avcodec;
   ppAVCodec = ^pAVCodec;
   pAVCodecContext = ^AVCodecContext;
   ppAVCodecContext = ^pAVCodecContext;
   pAVCodecDefault = ^AVCodecDefault;
   pAVSubtitle = ^AVSubtitle;
   avcodec = Record
      name: pAnsiChar;
      long_name: pAnsiChar;
      _type: AVMediaType;
      id: AVCodecID;
      capabilities: int;
      supported_framerates: pAVRational;
      pix_fmts: pAVPixelFormat;
      supported_samplerates: pInt;
      sample_fmts: pAVSampleFormat;
      channel_layouts: puint64_t;
      max_lowres: uint8_t;
      priv_class: pAVClass;
      profiles: pAVProfile;
      wrapper_name: pAnsiChar;
      priv_data_size: int;
      next: pAVCodec;
      init_thread_copy: Function(ctx: pAVCodecContext): int; cdecl;
      update_thread_context: Function(dst: pAVCodecContext; Const src: pAVCodecContext): int; cdecl;
      defaults: pAVCodecDefault;
      init_static_data: Procedure(codec: pAVCodec); cdecl;
      init: Function(ctx: pAVCodecContext): int; cdecl;
      encode_sub: Function(ctx: pAVCodecContext; buf: puint8_t; buf_size: int; Const sub: pAVSubtitle): int; cdecl;
      encode2: Function(avctx: pAVCodecContext; avpkt: pAVPacket; Const frame: pAVFrame; got_packet_ptr: pInt): int; cdecl;
      decode: Function(cnt: pAVCodecContext; outdata: Pointer; outdata_size: pInt; avpkt: pAVPacket): int; cdecl;
      close: Function(ctx: pAVCodecContext): int; cdecl;
      send_frame: Function(avctx: pAVCodecContext; Const frame: pAVFrame): int; cdecl;
      receive_packet: Function(avctx: pAVCodecContext; avpkt: pAVPacket): int; cdecl;
      receive_frame: Function(avctx: pAVCodecContext; frame: pAVFrame): int; cdecl;
      flush: Procedure(ctx: pAVCodecContext); cdecl;
      caps_internal: int;
      bsfs: pAnsiChar;
      hw_configs: ppAVCodecHWConfigInternal;
   End;

   TAVCodecContext_execute = Function(c2: pAVCodecContext; arg: Pointer): int; cdecl;
   TAVCodecContext_execute2 = Function(c2: pAVCodecContext; arg: Pointer; jobnr: int; threadnr: int): int; cdecl;
   AVCodecContext = Record
      av_class: pAVClass;
      log_level_offset: int;
      codec_type: AVMediaType;
      codec: pAVCodec;
      codec_id: AVCodecID;
      codec_tag: unsigned;
      priv_data: Pointer;
      internal: pAVCodecInternal;
      opaque: Pointer;
      bit_rate: int64_t;
      bit_rate_tolerance: int;
      global_quality: int;
      compression_level: int;
      flags: int;
      flags2: int;
      extradata: puint8_t;
      extradata_size: int;
      time_base: AVRational;
      ticks_per_frame: int;
      delay: int;
      width, height: int;
      coded_width, coded_height: int;
      gop_size: int;
      pix_fmt: AVPixelFormat;
      draw_horiz_band: Procedure(s: pAVCodecContext; Const src: pAVFrame; offset: pAVNDPArray; y, _type, height: int); cdecl;
      get_format: function(s: PAVCodecContext; const fmt: PAVPixelFormat): AVPixelFormat; cdecl;
      max_b_frames: int;
      b_quant_factor: float;
      b_frame_strategy: int;
      b_quant_offset: float;
      has_b_frames: int;
      mpeg_quant: int;
      i_quant_factor: float;
      i_quant_offset: float;
      lumi_masking: float;
      temporal_cplx_masking: float;
      spatial_cplx_masking: float;
      p_masking: float;
      dark_masking: float;
      slice_count: int;
      prediction_method: int;
      slice_offset: pInt;
      sample_aspect_ratio: AVRational;
      me_cmp: int;
      me_sub_cmp: int;
      mb_cmp: int;
      ildct_cmp: int;
      dia_size: int;
      last_predictor_count: int;
      pre_me: int;
      me_pre_cmp: int;
      pre_dia_size: int;
      me_subpel_quality: int;
      me_range: int;
      slice_flags: int;
      mb_decision: int;
      intra_matrix: puint16_t;
      inter_matrix: puint16_t;
      scenechange_threshold: int;
      noise_reduction: int;
      intra_dc_precision: int;
      skip_top: int;
      skip_bottom: int;
      mb_lmin: int;
      mb_lmax: int;
      me_penalty_compensation: int;
      bidir_refine: int;
      brd_scale: int;
      keyint_min: int;
      refs: int;
      chromaoffset: int;
      mv0_threshold: int;
      b_sensitivity: int;
      color_primaries: AVColorPrimaries;
      color_trc: AVColorTransferCharacteristic;
      colorspace: AVColorSpace;
      color_range: AVColorRange;
      chroma_sample_location: AVChromaLocation;
      slices: int;
      field_order: AVFieldOrder;
      sample_rate: int;
      channels: int;
      sample_fmt: AVSampleFormat;
      frame_size: int;
      frame_number: int;
      block_align: int;
      cutoff: int;
      channel_layout: uint64_t;
      request_channel_layout: uint64_t;
      audio_service_type: AVAudioServiceType;
      request_sample_fmt: AVSampleFormat;
      get_buffer2: Function(s: pAVCodecContext; frame: pAVFrame; flags: int): int; cdecl;
      refcounted_frames: int;
      qcompress: float;
      qblur: float;
      qmin: int;
      qmax: int;
      max_qdiff: int;
      rc_buffer_size: int;
      rc_override_count: int;
      rc_override: pRcOverride;
      rc_max_rate: int64_t;
      rc_min_rate: int64_t;
      rc_max_available_vbv_use: float;
      rc_min_vbv_overflow_use: float;
      rc_initial_buffer_occupancy: int;
      coder_type: int;
      context_model: int;
      frame_skip_threshold: int;
      frame_skip_factor: int;
      frame_skip_exp: int;
      frame_skip_cmp: int;
      trellis: int;
      min_prediction_order: int;
      max_prediction_order: int;
      timecode_frame_start: int64_t;
      rtp_callback: Procedure(avctx: pAVCodecContext; data: Pointer; size: int; mb_nb: int); cdecl;
      rtp_payload_size: int;
      mv_bits: int;
      header_bits: int;
      i_tex_bits: int;
      p_tex_bits: int;
      i_count: int;
      p_count: int;
      skip_count: int;
      misc_bits: int;
      frame_bits: int;
      stats_out: pAnsiChar;
      stats_in: pAnsiChar;
      workaround_bugs: int;
      strict_std_compliance: int;
      error_concealment: int;
      debug: int;
      debug_mv: int;
      err_recognition: int;
      reordered_opaque: int64_t;
      hwaccel: pAVHWAccel;
      hwaccel_context: Pointer;
      error: TAVNDPArray_uint64_t;
      dct_algo: int;
      idct_algo: int;
      bits_per_coded_sample: int;
      bits_per_raw_sample: int;
      lowres: int;
      coded_frame: pAVFrame ;
      thread_count: int;
      thread_type: int;
      active_thread_type: int;
      thread_safe_callbacks: int;
      execute: Function(c: pAVCodecContext; func: TAVCodecContext_execute; arg2: Pointer; ret: pInt; count: int; size: int): int; cdecl;
      execute2: Function(c: pAVCodecContext; func: TAVCodecContext_execute2; arg2: Pointer; ret: pInt; count: int): int; cdecl;
      nsse_weight: int;
      profile: int;
      level: int;
      skip_loop_filter: AVDiscard;
      skip_idct: AVDiscard;
      skip_frame: AVDiscard;
      subtitle_header: puint8_t;
      subtitle_header_size: int;
      vbv_delay: uint64_t;
      side_data_only_packets: int;
      initial_padding: int;
      framerate: AVRational;
      sw_pix_fmt: AVPixelFormat;
      pkt_timebase: AVRational;
      codec_descriptor: pAVCodecDescriptor;
      pts_correction_num_faulty_pts: int64_t;
      pts_correction_num_faulty_dts: int64_t;
      pts_correction_last_pts: int64_t;
      pts_correction_last_dts: int64_t;
      sub_charenc: pAnsiChar;
      sub_charenc_mode: int;
      skip_alpha: int;
      seek_preroll: int;
      chroma_intra_matrix: puint16_t;
      dump_separator: puint8_t;
      codec_whitelist: pAnsiChar;
      properties: unsigned;
      coded_side_data: pAVPacketSideData;
      nb_coded_side_data: int;
      hw_frames_ctx: pAVBufferRef;
      sub_text_format: int;
      trailing_padding: int;
      max_pixels: int64_t;
      hw_device_ctx: pAVBufferRef;
      hwaccel_flags: int;
      apply_cropping: int;
      extra_hw_frames: int;
      discard_damaged_percentage: int;
   End;

   MpegEncContext = Record
   End;
   pMpegEncContext = ^MpegEncContext;

   AVHWAccel = Record
      name: pAnsiChar;
      _type: AVMediaType;
      id: AVCodecID;
      pix_fmt: AVPixelFormat;
      capabilities: int;
      alloc_frame: Function(avctx: pAVCodecContext; frame: pAVFrame): int; cdecl;
      start_frame: Function(avctx: pAVCodecContext; Const buf: puint8_t; buf_size: uint32_t): int; cdecl;
      decode_params: Function(avctx: pAVCodecContext; _type: int; Const buf: puint8_t; buf_size: uint32_t): int; cdecl;
      decode_slice: Function(avctx: pAVCodecContext; Const buf: puint8_t; buf_size: uint32_t): int; cdecl;
      end_frame: Function(avctx: pAVCodecContext): int; cdecl;
      frame_priv_data_size: int;
      decode_mb: Procedure(s: pMpegEncContext); cdecl;
      init: Function(avctx: pAVCodecContext): int; cdecl;
      uninit: Function(avctx: pAVCodecContext): int; cdecl;
      priv_data_size: int;
      caps_internal: int;
      frame_params: Function(avctx: pAVCodecContext; hw_frames_ctx: pAVBufferRef): int; cdecl;
   End;

   pAVPicture = ^AVPicture;
   AVPicture = Record
      data: TAVNDPArray_puint8_t;
      linesize: TAVNDPArray_int;
   End;

   AVSubtitleType = (
      SUBTITLE_NONE, SUBTITLE_BITMAP,
      SUBTITLE_TEXT,
      SUBTITLE_ASS);

   AVSubtitleRect = Record
      x: int;
      y: int;
      w: int;
      h: int;
      nb_colors: int;
      pict: AVPicture;
      data: puint8_t_array_4;
      linesize: Tint_array_4;
      _type: AVSubtitleType;
      text: pAnsiChar;
      ass: pAnsiChar;
      flags: int;
   End;

   pAVSubtitleRect = ^AVSubtitleRect;
   ppAVSubtitleRect = ^pAVSubtitleRect;
   AVSubtitle = Record
      format: uint16_t;
      start_display_time: uint32_t;
      end_display_time: uint32_t;
      num_rects: unsigned;
      rects: ppAVSubtitleRect;
      pts: int64_t;
   End;

   pAVCodecParameters = ^AVCodecParameters;
   AVCodecParameters = Record
      codec_type: AVMediaType;
      codec_id: AVCodecID;
      codec_tag:
      Packed Record
         Case Integer Of
            0:(tag: Cardinal);
            1:(fourcc: Array[0..3] Of AnsiChar);
            2:(fourbb: Array[0..3] Of Byte);
      End;
      extradata: puint8_t;
      extradata_size: int;
      format: int;
      bit_rate: int64_t;
      bits_per_coded_sample: int;
      bits_per_raw_sample: int;
      profile: int;
      level: int;
      width: int;
      height: int;
      sample_aspect_ratio: AVRational;
      field_order: AVFieldOrder;
      color_range: AVColorRange;
      color_primaries: AVColorPrimaries;
      color_trc: AVColorTransferCharacteristic;
      color_space: AVColorSpace;
      chroma_location: AVChromaLocation;
      video_delay: int;
      channel_layout: uint64_t;
      channels: int;
      sample_rate: int;
      block_align: int;
      frame_size: int;
      initial_padding: int;
      trailing_padding: int;
      seek_preroll: int;
   End;

Const
   AV_PARSER_PTS_NB = 4;
   PARSER_FLAG_COMPLETE_FRAMES = $0001;
   PARSER_FLAG_ONCE = $0002;
   PARSER_FLAG_FETCHED_OFFSET = $0004;
   PARSER_FLAG_USE_CODEC_TS = $1000;

Type
   TAPPNArray_int64_t = Array[0..AV_PARSER_PTS_NB - 1] Of int64_t;
   AVPictureStructure = (
      AV_PICTURE_STRUCTURE_UNKNOWN,
      AV_PICTURE_STRUCTURE_TOP_FIELD,
      AV_PICTURE_STRUCTURE_BOTTOM_FIELD,
      AV_PICTURE_STRUCTURE_FRAME
      );

   pAVCodecParserContext = ^AVCodecParserContext;
   pAVCodecParser = ^AVCodecParser;
   AVCodecParserContext = Record
      priv_data: Pointer;
      parser: pAVCodecParser;
      frame_offset: int64_t;
      cur_offset: int64_t;
      next_frame_offset: int64_t;
      pict_type: int;
      repeat_pict: int;
      pts: int64_t;
      dts: int64_t;
      last_pts: int64_t;
      last_dts: int64_t;
      fetch_timestamp: int;
      cur_frame_start_index: int;
      cur_frame_offset: TAPPNArray_int64_t;
      cur_frame_pts: TAPPNArray_int64_t;
      cur_frame_dts: TAPPNArray_int64_t;
      flags: int;
      offset: int64_t;
      cur_frame_end: TAPPNArray_int64_t;
      key_frame: int;
      convergence_duration: int64_t;
      dts_sync_point: int;
      dts_ref_dts_delta: int;
      pts_dts_delta: int;
      cur_frame_pos: TAPPNArray_int64_t;
      pos: int64_t;
      last_pos: int64_t;
      duration: int;
      field_order: AVFieldOrder;
      picture_structure: AVPictureStructure;
      output_picture_number: int;
      width: int;
      height: int;
      coded_width: int;
      coded_height: int;
      format: int;
   End;

   Tcodec_ids_array_5_int = Array[0..4] Of int;

   AVCodecParser = Record
      codec_ids: Tcodec_ids_array_5_int;
      priv_data_size: int;
      parser_init: Function(s: pAVCodecParserContext): int; cdecl;
      parser_parse: Function(s: pAVCodecParserContext; avctx: pAVCodecContext; Const poutbuf: puint8_t; poutbuf_size: pInt; Const buf: puint8_t; buf_size: int)
      : int; cdecl;
      parser_close: Procedure(s: pAVCodecParserContext); cdecl;
      split: Function(avctx: pAVCodecContext; Const buf: puint8_t; buf_size: int): int; cdecl;
      next: pAVCodecParser;
   End;

Type
   Tavcodec_default_execute_func = Function(c2: pAVCodecContext; arg2: Pointer): int; cdecl;
   Tavcodec_default_execute2_func = Function(c2: pAVCodecContext; arg2: Pointer; p1, p2: int): int; cdecl;

Type
   pAVBitStreamFilter = ^AVBitStreamFilter;
   pAVBitStreamFilterContext = ^AVBitStreamFilterContext;
   AVBitStreamFilterContext = Record
      priv_data: Pointer;
      filter: pAVBitStreamFilter;
      parser: pAVCodecParserContext;
      next: pAVBitStreamFilterContext;
      args: pAnsiChar;
   End;

   pAVBSFInternal = ^AVBSFInternal;
   AVBSFInternal = Record
   End;

   pAVBSFContext = ^AVBSFContext;
   AVBSFContext = Record
      av_class: pAVClass;
      filter: pAVBitStreamFilter;
      internal: pAVBSFInternal;
      priv_data: Pointer;
      par_in: pAVCodecParameters;
      par_out: pAVCodecParameters;
      time_base_in: AVRational;
      time_base_out: AVRational;
   End;

   AVBitStreamFilter = Record
      name: pAnsiChar;
      codec_ids: pAVCodecID;
      priv_class: pAVClass;
      priv_data_size: int;
      init: Function(ctx: pAVBSFContext): int; cdecl;
      filter: Function(ctx: pAVBSFContext; pkt: pAVPacket): int; cdecl;
      close: Procedure(ctx: pAVBSFContext); cdecl;
      flush: Procedure(ctx: pAVBSFContext); cdecl;
   End;

Type
   pAVBSFList = ^AVBSFList;
   AVBSFList = Record
   End;

   AVLockOp = (
      AV_LOCK_CREATE,
      AV_LOCK_OBTAIN,
      AV_LOCK_RELEASE,
      AV_LOCK_DESTROY
      );

   Tav_lockmgr_register_cb_func = Function(Var mutex: Pointer; op: AVLockOp): int; cdecl;

   pAVVorbisParseContext = ^AVVorbisParseContext;
   AVVorbisParseContext = Record
   End;

Const
   VORBIS_FLAG_HEADER = $00000001;
   VORBIS_FLAG_COMMENT = $00000002;
   VORBIS_FLAG_SETUP = $00000004;

Type
   vaapi_context = Record
      display: Pointer;
      config_id: uint32_t;
      context_id: uint32_t;
   End;

   pAVDCT = ^AVDCT;
   AVDCT = Record
      av_class: pAVClass;
      idct: Procedure(block: pint16_t); cdecl;
      idct_permutation: Array[0..64 - 1] Of uint8_t;
      fdct: Procedure(block: pint16_t); cdecl;
      dct_algo: int;
      idct_algo: int;
      get_pixels: Procedure(block: int16_t; Const pixels: puint8_t; line_size: ptrdiff_t); cdecl;
      bits_per_sample: int;
   End;

   pAVMediaCodecContext = ^AVMediaCodecContext;
   AVMediaCodecContext = Record
      surface: Pointer;
   End;

   pAVMediaCodecBuffer = ^AVMediaCodecBuffer;
   AVMediaCodecBuffer = Record
   End;

   FFTSample = float;
   pFFTSample = ^FFTSample;
   pFFTComplex = ^FFTComplex;
   FFTComplex = Record
      re, im: FFTSample;
   End;
   pFFTContext = ^FFTContext;
   FFTContext = Record
   End;

   RDFTransformType = (DFT_R2C, IDFT_C2R, IDFT_R2C, DFT_C2R);
   pRDFTContext = ^RDFTContext;
   RDFTContext = Record
   End;

   pDCTContext = ^DCTContext;
   DCTContext = Record
   End;
   DCTTransformType = (
      DCT_II = 0, DCT_III, DCT_I, DST_I);

Const
   DV_PROFILE_BYTES = (6 * 80);

Type
   Taudio_shuffle = Array[0..8] Of uint8_t;
   paudio_shuffle = ^Taudio_shuffle;
   pAVDVProfile = ^AVDVProfile;
   AVDVProfile = Record
      dsf: int;
      video_stype: int;
      frame_size: int;
      difseg_size: int;
      n_difchan: int;
      time_base: AVRational;
      ltc_divisor: int;
      height: int;
      width: int;
      sar: Array[0..1] Of AVRational;
      pix_fmt: AVPixelFormat;
      bpm: int;
      block_sizes: puint8_t;
      audio_stride: int;
      audio_min_samples: Array[0..2] Of int;
      audio_samples_dist: Array[0..4] Of int;
      audio_shuffle: paudio_shuffle;
   End;

Const
   MAX_DWT_LEVELS = 5;

Type
   DiracParseCodes = (
      DIRAC_PCODE_SEQ_HEADER = $00,
      DIRAC_PCODE_END_SEQ = $10,
      DIRAC_PCODE_AUX = $20,
      DIRAC_PCODE_PAD = $30,
      DIRAC_PCODE_PICTURE_CODED = $08,
      DIRAC_PCODE_PICTURE_RAW = $48,
      DIRAC_PCODE_PICTURE_LOW_DEL = $C8,
      DIRAC_PCODE_PICTURE_HQ = $E8,
      DIRAC_PCODE_INTER_NOREF_CO1 = $0A,
      DIRAC_PCODE_INTER_NOREF_CO2 = $09,
      DIRAC_PCODE_INTER_REF_CO1 = $0D,
      DIRAC_PCODE_INTER_REF_CO2 = $0E,
      DIRAC_PCODE_INTRA_REF_CO = $0C,
      DIRAC_PCODE_INTRA_REF_RAW = $4C,
      DIRAC_PCODE_INTRA_REF_PICT = $CC,
      DIRAC_PCODE_MAGIC = $42424344);

   DiracVersionInfo = Record
      major: int;
      minor: int;
   End;

   pAVDiracSeqHeader = ^AVDiracSeqHeader;
   AVDiracSeqHeader = Record
      width: unsigned;
      height: unsigned;
      chroma_format: uint8_t;
      interlaced: uint8_t;
      top_field_first: uint8_t;
      frame_rate_index: uint8_t;
      aspect_ratio_index: uint8_t;
      clean_width: uint16_t;
      clean_height: uint16_t;
      clean_left_offset: uint16_t;
      clean_right_offset: uint16_t;
      pixel_range_index: uint8_t;
      color_spec_index: uint8_t;
      profile: int;
      level: int;
      framerate: AVRational;
      sample_aspect_ratio: AVRational;
      pix_fmt: AVPixelFormat;
      color_range: AVColorRange;
      color_primaries: AVColorPrimaries;
      color_trc: AVColorTransferCharacteristic;
      colorspace: AVColorSpace;
      version: DiracVersionInfo;
      bit_depth: int;
   End;

Const
   AV_PKT_DATA_QUALITY_FACTOR: AVPacketSideDataType = AV_PKT_DATA_QUALITY_STATS;

Type

    mfxSession =Pointer;
    PmfxExtBuffer  = ^mfxExtBuffer;
    mfxExtBuffer =Pointer;
    PAVQSVContext = ^AVQSVContext;
    AVQSVContext = record
        session : mfxSession;
        iopattern : longint;
        ext_buffers : ^PmfxExtBuffer;
        nb_ext_buffers : longint;
        opaque_alloc : longint;
        nb_opaque_surfaces : longint;
        opaque_surfaces : PAVBufferRef;
        opaque_alloc_type : longint;
      end;

//------------------------------------------------

 Type

   Tav_codec_get_pkt_timebase = Function(Const avctx: pAVCodecContext): AVRational; cdecl;
   Tav_codec_set_pkt_timebase = Procedure(avctx: pAVCodecContext; val: AVRational); cdecl;
   Tav_codec_get_codec_descriptor = Function(Const avctx: pAVCodecContext): pAVCodecDescriptor; cdecl;
   Tav_codec_set_codec_descriptor = Procedure(avctx: pAVCodecContext; Const desc: pAVCodecDescriptor); cdecl;
   Tav_codec_get_codec_properties = Function(Const avctx: pAVCodecContext): unsigned; cdecl;
   Tav_codec_get_lowres = Function(Const avctx: pAVCodecContext): int; cdecl;
   Tav_codec_set_lowres = Procedure(avctx: pAVCodecContext; val: int); cdecl;
   Tav_codec_get_seek_preroll = Function(Const avctx: pAVCodecContext): int; cdecl;
   Tav_codec_set_seek_preroll = Procedure(avctx: pAVCodecContext; val: int); cdecl;
   Tav_codec_get_chroma_intra_matrix = Function(Const avctx: pAVCodecContext): puint16_t; cdecl;
   Tav_codec_set_chroma_intra_matrix = Procedure(avctx: pAVCodecContext; val: puint16_t); cdecl;
   Tav_codec_get_max_lowres = Function(Const codec: pAVCodec): int; cdecl;
   Tavcodec_get_hw_config = Function(Const codec: pAVCodec; index: int): pAVCodecHWConfig; cdecl;
   Tav_codec_iterate = Function(Var opaque: Pointer): pAVCodec; cdecl;
   Tav_codec_next = Function(Const c: pAVCodec): pAVCodec; cdecl;
   Tavcodec_version = Function(): unsigned; cdecl;
   Tavcodec_configuration = Function(): pAnsiChar; cdecl;
   Tavcodec_license = Function(): pAnsiChar; cdecl;
   Tavcodec_register = Procedure(codec: pAVCodec); cdecl;
   Tavcodec_register_all = Procedure(); cdecl;
   Tavcodec_alloc_context3 = Function(Const codec: pAVCodec): pAVCodecContext; cdecl;
   Tavcodec_free_context = Procedure(Var avctx: pAVCodecContext); cdecl;
   Tavcodec_get_context_defaults3 = Function(s: pAVCodecContext; Const codec: pAVCodec): int; cdecl;
   Tavcodec_get_class = Function(): pAVClass; cdecl;
   Tavcodec_get_frame_class = Function(): pAVClass; cdecl;
   Tavcodec_get_subtitle_rect_class = Function(): pAVClass; cdecl;
   Tavcodec_copy_context = Function(dest: pAVCodecContext; Const src: pAVCodecContext): int; cdecl;
   Tavcodec_parameters_alloc = Function(): pAVCodecParameters; cdecl;
   Tavcodec_parameters_free = Procedure(Var par: pAVCodecParameters); cdecl;
   Tavcodec_parameters_copy = Function(dst: pAVCodecParameters; Const src: pAVCodecParameters): int; cdecl;
   Tavcodec_parameters_from_context = Function(par: pAVCodecParameters; Const codec: pAVCodecContext): int; cdecl;
   Tavcodec_parameters_to_context = Function(codec: pAVCodecContext; Const par: pAVCodecParameters): int; cdecl;
   Tavcodec_open2 = Function(avctx: pAVCodecContext; Const codec: pAVCodec; options: ppAVDictionary): int; cdecl;
   Tavcodec_close = Function(avctx: pAVCodecContext): int; cdecl;
   Tavsubtitle_free = Procedure(sub: pAVSubtitle); cdecl;
   Tav_packet_alloc = Function(): pAVPacket; cdecl;
   Tav_packet_clone = Function(Const src: pAVPacket): pAVPacket; cdecl;
   Tav_packet_free = Procedure(Var pkt: pAVPacket); cdecl;
   Tav_init_packet = Procedure(Var pkt: AVPacket); cdecl;
   Tav_new_packet = Function(pkt: pAVPacket; size: int): int; cdecl;
   Tav_shrink_packet = Procedure(pkt: pAVPacket; size: int); cdecl;
   Tav_grow_packet = Function(pkt: pAVPacket; grow_by: int): int; cdecl;
   Tav_packet_from_data = Function(pkt: pAVPacket; data: puint8_t; size: int): int; cdecl;
   Tav_dup_packet = Function(pkt: pAVPacket): int; cdecl;
   Tav_copy_packet = Function(dst: pAVPacket; Const src: pAVPacket): int; cdecl;
   Tav_copy_packet_side_data = Function(dst: pAVPacket; Const src: pAVPacket): int; cdecl;
   Tav_free_packet = Procedure(Var pkt: AVPacket); cdecl;
   Tav_packet_new_side_data = Function(pkt: pAVPacket; _type: AVPacketSideDataType; size: int): puint8_t; cdecl;
   Tav_packet_add_side_data = Function(pkt: pAVPacket; _type: AVPacketSideDataType; data: puint8_t; size: size_t): int; cdecl;
   Tav_packet_shrink_side_data = Function(pkt: pAVPacket; _type: AVPacketSideDataType; size: int): int; cdecl;
   Tav_packet_get_side_data = Function(Const pkt: pAVPacket; _type: AVPacketSideDataType; size: pInt): puint8_t; cdecl;
   Tav_packet_merge_side_data = Function(pkt: pAVPacket): int; cdecl;
   Tav_packet_split_side_data = Function(pkt: pAVPacket): int; cdecl;
   Tav_packet_side_data_name = Function(_type: AVPacketSideDataType): pAnsiChar; cdecl;
   Tav_packet_pack_dictionary = Function(dict: pAVDictionary; size: pInt): puint8_t; cdecl;
   Tav_packet_unpack_dictionary = Function(Const data: puint8_t; size: int; Var dict: pAVDictionary): int; cdecl;
   Tav_packet_free_side_data = Procedure(pkt: pAVPacket); cdecl;
   Tav_packet_ref = Function(dst: pAVPacket; Const src: pAVPacket): int; cdecl;
   Tav_packet_unref = Procedure(Var pkt: AVPacket); cdecl;
   Tav_packet_move_ref = Procedure(dst: pAVPacket; Var src: AVPacket); cdecl;
   Tav_packet_copy_props = Function(dst: pAVPacket; Const src: pAVPacket): int; cdecl;
   Tav_packet_make_refcounted = Function(pkt: pAVPacket): int; cdecl;
   Tav_packet_make_writable = Function(pkt: pAVPacket): int; cdecl;
   Tav_packet_rescale_ts = Procedure(pkt: pAVPacket; tb_src: AVRational; tb_dst: AVRational); cdecl;
   Tavcodec_find_decoder = Function(id: AVCodecID): pAVCodec; cdecl;
   Tavcodec_find_decoder_by_name = Function(Const name: pAnsiChar): pAVCodec; cdecl;
   Tavcodec_default_get_buffer2 = Function(s: pAVCodecContext; frame: pAVFrame; flags: int): int; cdecl;
   Tavcodec_align_dimensions = Procedure(s: pAVCodecContext; width: pInt; height: pInt); cdecl;
   Tavcodec_align_dimensions2 = Procedure(s: pAVCodecContext; Var width: int; Var height: int; linesize_align: TAVNDPArray_int); cdecl;
   Tavcodec_enum_to_chroma_pos = Function(Var xpos: int; ypos: int; pos: AVChromaLocation): int; cdecl;
   Tavcodec_chroma_pos_to_enum = Function(xpos, ypos: int): AVChromaLocation; cdecl;
   Tavcodec_decode_audio4 = Function(avctx: pAVCodecContext; frame: pAVFrame; Var got_frame_ptr: int; Const avpkt: pAVPacket): int; cdecl;
   Tavcodec_decode_video2 = Function(avctx: pAVCodecContext; picture: pAVFrame; Var got_picture_ptr: int; Const avpkt: pAVPacket): int; cdecl;
   Tavcodec_decode_subtitle2 = Function(avctx: pAVCodecContext; Var sub: AVSubtitle; Var got_sub_ptr: int; avpkt: pAVPacket): int; cdecl;
   Tavcodec_send_packet = Function(avctx: pAVCodecContext; Var avpkt: AVPacket): int; cdecl;
   Tavcodec_receive_frame = Function(avctx: pAVCodecContext; frame: pAVFrame): int; cdecl;
   Tavcodec_send_frame = Function(avctx: pAVCodecContext; Const frame: pAVFrame): int; cdecl;
   Tavcodec_receive_packet = Function(avctx: pAVCodecContext; Var avpkt: AVPacket): int; cdecl;
   Tavcodec_get_hw_frames_parameters = Function(avctx: pAVCodecContext; device_ref: pAVBufferRef; hw_pix_fmt: AVPixelFormat; Var out_frames_ref: pAVBufferRef): int;cdecl;
   Tav_parser_iterate = Function(Var opaque: Pointer): pAVCodecParser; cdecl;
   Tav_parser_next = Function(Const c: pAVCodecParser): pAVCodecParser; cdecl;
   Tav_register_codec_parser = Procedure(parser: pAVCodecParser); cdecl;
   Tav_parser_init = Function(codec_id: int): pAVCodecParserContext; cdecl;
   Tav_parser_parse2 = Function(s: pAVCodecParserContext; avctx: pAVCodecContext; Var poutbuf: puint8_t; Var poutbuf_size: int; Const buf: puint8_t; buf_size: int;pts: int64_t; dts: int64_t; pos: int64_t): int; cdecl;
   Tav_parser_change = Function(s: pAVCodecParserContext; avctx: pAVCodecContext; Var poutbuf: puint8_t; Var poutbuf_size: int; Const buf: puint8_t; buf_size: int;keyframe: int): int; cdecl;
   Tav_parser_close = Procedure(s: pAVCodecParserContext); cdecl;
   Tavcodec_find_encoder = Function(id: AVCodecID): pAVCodec; cdecl;
   Tavcodec_find_encoder_by_name = Function(Const name: pAnsiChar): pAVCodec; cdecl;
   Tavcodec_encode_audio2 = Function(avctx: pAVCodecContext; avpkt: pAVPacket; Const frame: pAVFrame; Var got_packet_ptr: int): int; cdecl;
   Tavcodec_encode_video2 = Function(avctx: pAVCodecContext; Var avpkt: AVPacket; Const frame: pAVFrame; Var got_packet_ptr: int): int; cdecl;
   Tavcodec_encode_subtitle = Function(avctx: pAVCodecContext; buf: puint8_t; buf_size: int; Const sub: pAVSubtitle): int; cdecl;
   Tavpicture_alloc = Function(Var picture: AVPicture; pix_fmt: AVPixelFormat; width: int; height: int): int; cdecl;
   Tavpicture_free = Procedure(picture: pAVPicture); cdecl;
   Tavpicture_fill = Function(picture: pAVPicture; Const ptr: puint8_t; pix_fmt: AVPixelFormat; width: int; height: int): int; cdecl;
   Tavpicture_layout = Function(Const src: pAVPicture; pix_fmt: AVPixelFormat; width: int; height: int; dest: punsignedchar; dest_size: int): int; cdecl;
   Tavpicture_get_size = Function(pix_fmt: AVPixelFormat; width: int; height: int): int; cdecl;
   Tav_picture_copy = Procedure(dst: pAVPicture; Const src: pAVPicture; pix_fmt: AVPixelFormat; width: int; height: int); cdecl;
   Tav_picture_crop = Function(dst: pAVPicture; Const src: pAVPicture; pix_fmt: AVPixelFormat; top_band: int; left_band: int): int; cdecl;
   Tav_picture_pad = Function(dst: pAVPicture; Const src: pAVPicture; height: int; width: int; pix_fmt: AVPixelFormat; padtop: int; padbottom: int; padleft: int;padright: int; Var color: int): int; cdecl;
   Tavcodec_get_chroma_sub_sample = Procedure(pix_fmt: AVPixelFormat; Var h_shift, v_shift: int); cdecl;
   Tavcodec_pix_fmt_to_codec_tag = Function(pix_fmt: AVPixelFormat): unsignedint; cdecl;
   Tavcodec_get_pix_fmt_loss = Function(dst_pix_fmt: AVPixelFormat; src_pix_fmt: AVPixelFormat; has_alpha: int): int; cdecl;
   Tavcodec_find_best_pix_fmt_of_list = Function(Const pix_fmt_list: pAVPixelFormat; src_pix_fmt: AVPixelFormat; has_alpha: int; Var loss_ptr: int): AVPixelFormat;cdecl;
   Tavcodec_find_best_pix_fmt_of_2 = Function(dst_pix_fmt1: AVPixelFormat; dst_pix_fmt2: AVPixelFormat; src_pix_fmt: AVPixelFormat; has_alpha: int; Var loss_ptr: int): AVPixelFormat; cdecl;
   Tavcodec_find_best_pix_fmt2 = Function(dst_pix_fmt1: AVPixelFormat; dst_pix_fmt2: AVPixelFormat; src_pix_fmt: AVPixelFormat; has_alpha: int; Var loss_ptr: int): AVPixelFormat; cdecl;
   Tavcodec_default_get_format = Function(s: pAVCodecContext; Const fmt: pAVPixelFormat): AVPixelFormat; cdecl;
   Tav_get_codec_tag_string = Function(buf: pAnsiChar; buf_size: size_t; codec_tag: unsignedint): size_t; cdecl;
   Tavcodec_string = Procedure(buf: pAnsiChar; buf_size: int; enc: pAVCodecContext; encode: int); cdecl;
   Tav_get_profile_name = Function(Const codec: pAVCodec; profile: int): pAnsiChar; cdecl;
   Tavcodec_profile_name = Function(codec_id: AVCodecID; profile: int): pAnsiChar; cdecl;
   Tavcodec_default_execute = Function(c: pAVCodecContext; func: Tavcodec_default_execute_func; arg: Pointer; Var ret: int; count: int; size: int): int; cdecl;
   Tavcodec_default_execute2 = Function(c: pAVCodecContext; func: Tavcodec_default_execute2_func; arg: Pointer; Var ret: int; count: int): int; cdecl;
   Tavcodec_fill_audio_frame = Function(frame: pAVFrame; nb_channels: int; sample_fmt: AVSampleFormat; Const buf: puint8_t; buf_size: int; align: int): int; cdecl;
   Tavcodec_flush_buffers = Procedure(avctx: pAVCodecContext); cdecl;
   Tav_get_bits_per_sample = Function(codec_id: AVCodecID): int; cdecl;
   Tav_get_pcm_codec = Function(fmt: AVSampleFormat; be: int): AVCodecID; cdecl;
   Tav_get_exact_bits_per_sample = Function(codec_id: AVCodecID): int; cdecl;
   Tav_get_audio_frame_duration = Function(avctx: pAVCodecContext; frame_bytes: int): int; cdecl;
   Tav_get_audio_frame_duration2 = Function(par: pAVCodecParameters; frame_bytes: int): int; cdecl;
   Tav_register_bitstream_filter = Procedure(bsf: pAVBitStreamFilter); cdecl;
   Tav_bitstream_filter_init = Function(Const name: pAnsiChar): pAVBitStreamFilterContext; cdecl;
   Tav_bitstream_filter_filter = Function(bsfc: pAVBitStreamFilterContext; avctx: pAVCodecContext; Const args: pAnsiChar; Var poutbuf: puint8_t;Var poutbuf_size: int; Const buf: puint8_t; buf_size: int; keyframe: int): int; cdecl;
   Tav_bitstream_filter_close = Procedure(bsf: pAVBitStreamFilterContext); cdecl;
   Tav_bitstream_filter_next = Function(Const f: pAVBitStreamFilter): pAVBitStreamFilter; cdecl;
   Tav_bsf_get_by_name = Function(Const name: pAnsiChar): pAVBitStreamFilter; cdecl;
   Tav_bsf_iterate = Function(Var opaque: Pointer): pAVBitStreamFilter; cdecl;
   Tav_bsf_next = Function(Var opaque: Pointer): pAVBitStreamFilter; cdecl;
   Tav_bsf_alloc = Function(Const filter: pAVBitStreamFilter; Var ctx: pAVBSFContext): int; cdecl;
   Tav_bsf_init = Function(ctx: pAVBSFContext): int; cdecl;
   Tav_bsf_send_packet = Function(ctx: pAVBSFContext; pkt: pAVPacket): int; cdecl;
   Tav_bsf_receive_packet = Function(ctx: pAVBSFContext; pkt: pAVPacket): int; cdecl;
   Tav_bsf_flush = Procedure(Var ctx: AVBSFContext); cdecl;
   Tav_bsf_free = Procedure(Var ctx: pAVBSFContext); cdecl;
   Tav_bsf_get_class = Function(): pAVClass; cdecl;
   Tav_bsf_list_alloc = Function(): pAVBSFList; cdecl;
   Tav_bsf_list_free = Procedure(Var lst: pAVBSFList); cdecl;
   Tav_bsf_list_append = Function(lst: pAVBSFList; bsf: pAVBSFContext): int; cdecl;
   Tav_bsf_list_append2 = Function(lst: pAVBSFList; Const bsf_name: pAnsiChar; Var options: pAVDictionary): int; cdecl;
   Tav_bsf_list_finalize = Function(Var lst: pAVBSFList; Var bsf: pAVBSFContext): int; cdecl;
   Tav_bsf_list_parse_str = Function(Const str: pAnsiChar; Var bsf: pAVBSFContext): int; cdecl;
   Tav_bsf_get_null_filter = Function(Var bsf: pAVBSFContext): int; cdecl;
   Tav_fast_padded_malloc = Procedure(ptr: Pointer; Var size: unsignedint; min_size: size_t); cdecl;
   Tav_fast_padded_mallocz = Procedure(ptr: Pointer; Var size: unsignedint; min_size: size_t); cdecl;
   Tav_xiphlacing = Function(s: punsignedchar; v: unsignedint): unsignedint; cdecl;
   Tav_register_hwaccel = Procedure(hwaccel: pAVHWAccel); cdecl;
   Tav_hwaccel_next = Function(Const hwaccel: pAVHWAccel): pAVHWAccel; cdecl;
   Tav_lockmgr_register = Function(cb: Tav_lockmgr_register_cb_func): int; cdecl;
   Tavcodec_get_type = Function(codec_id: AVCodecID): AVMediaType; cdecl;
   Tavcodec_get_name = Function(id: AVCodecID): pAnsiChar; cdecl;
   Tavcodec_is_open = Function(s: pAVCodecContext): int; cdecl;
   Tav_codec_is_encoder = Function(Const codec: pAVCodec): int; cdecl;
   Tav_codec_is_decoder = Function(Const codec: pAVCodec): int; cdecl;
   Tavcodec_descriptor_get = Function(id: pAVCodecID): pAVCodecDescriptor; cdecl;
   Tavcodec_descriptor_next = Function(Const prev: pAVCodecDescriptor): pAVCodecDescriptor; cdecl;
   Tavcodec_descriptor_get_by_name = Function(Const name): pAVCodecDescriptor; cdecl;
   Tav_cpb_properties_alloc = Function(size: psize_t): pAVCPBProperties; cdecl;
   Tav_ac3_parse_header = Function(Const buf: puint8_t; size: size_t; Var bitstream_id: uint8_t; Var frame_size: uint16_t): int; cdecl;
   Tav_adts_header_parse = Function(Const buf: puint8_t; Var samples: uint32_t; Var frames: uint8_t): int; cdecl;
   Tav_jni_set_java_vm = Function(vm: Pointer; log_ctx: Pointer): int; cdecl;
   Tav_jni_get_java_vm = Function(log_ctx: Pointer): Pointer; cdecl;
   Tav_vorbis_parse_init = Function(Const extradata: puint8_t; extradata_size: int): pAVVorbisParseContext; cdecl;
   Tav_vorbis_parse_free = Procedure(Var s: pAVVorbisParseContext); cdecl;
   Tav_vorbis_parse_frame_flags = Function(s: pAVVorbisParseContext; Const buf: puint8_t; buf_size: int; Var flags: int): int; cdecl;
   Tav_vorbis_parse_frame = Function(s: pAVVorbisParseContext; Const buf: puint8_t; buf_size: int): int; cdecl;
   Tav_vorbis_parse_reset = Procedure(s: pAVVorbisParseContext); cdecl;
   Tavcodec_dct_alloc = Function(): pAVDCT; cdecl;
   Tavcodec_dct_init = Function(p: pAVDCT): int; cdecl;
   Tavcodec_dct_get_class = Function(): pAVClass; cdecl;
   Tav_mediacodec_alloc_context = Function(): pAVMediaCodecContext; cdecl;
   Tav_mediacodec_default_init = Function(avctx: pAVCodecContext; ctx: pAVMediaCodecContext; surface: Pointer): int; cdecl;
   Tav_mediacodec_default_free = Procedure(avctx: pAVCodecContext); cdecl;
   Tav_mediacodec_release_buffer = Function(buffer: pAVMediaCodecBuffer; render: int): int; cdecl;
   Tav_mediacodec_render_buffer_at_time = Function(buffer: pAVMediaCodecBuffer; time: int64_t): int; cdecl;
   Tav_fft_init = Function(nbits: int; inverse: int): pFFTContext; cdecl;
   Tav_fft_permute = Procedure(s: pFFTContext; z: pFFTContext); cdecl;
   Tav_fft_calc = Procedure(s: pFFTContext; z: pFFTComplex); cdecl;
   Tav_fft_end = Procedure(s: pFFTContext); cdecl;
   Tav_mdct_init = Function(nbits: int; inverse: int; scale: double): pFFTContext; cdecl;
   Tav_imdct_calc = Procedure(s: pFFTContext; output: pFFTSample; Const input: pFFTSample); cdecl;
   Tav_imdct_half = Procedure(s: pFFTContext; output: pFFTSample; Const input: pFFTSample); cdecl;
   Tav_mdct_calc = Procedure(s: pFFTContext; output: pFFTSample; Const input: pFFTSample); cdecl;
   Tav_mdct_end = Procedure(s: pFFTContext); cdecl;
   Tav_rdft_init = Function(nbits: int; trans: RDFTransformType): pRDFTContext; cdecl;
   Tav_rdft_calc = Procedure(s: pRDFTContext; data: pFFTSample); cdecl;
   Tav_rdft_end = Procedure(s: pRDFTContext); cdecl;
   Tav_dct_init = Function(nbits: int; _type: DCTTransformType): pDCTContext; cdecl;
   Tav_dct_calc = Procedure(s: pDCTContext; data: pFFTSample); cdecl;
   Tav_dct_end = Procedure(s: pDCTContext); cdecl;
   Tav_dv_frame_profile = Function(Const sys: pAVDVProfile; Const frame: puint8_t; buf_size: unsigned): pAVDVProfile; cdecl;
   Tav_dv_codec_profile = Function(width: int; height: int; pix_fmt: AVPixelFormat): pAVDVProfile; cdecl;
   Tav_dv_codec_profile2 = Function(width: int; height: int; pix_fmt: AVPixelFormat; frame_rate: AVRational): pAVDVProfile; cdecl;
   Tav_dirac_parse_sequence_header = Function(Var dsh: pAVDiracSeqHeader; Const buf: puint8_t; buf_size: size_t; log_ctx: Pointer): int; cdecl;
   Tavcodec_default_get_encode_buffer = Function(s: PAVCodecContext; pkt: PAVPacket; flags: Integer): Integer; cdecl;
   Tav_qsv_alloc_context = Function():PAVQSVContext;cdecl;


//-------------------------------------------------
 Var

   av_codec_get_pkt_timebase : Tav_codec_get_pkt_timebase = Nil;
   av_codec_set_pkt_timebase : Tav_codec_set_pkt_timebase = Nil;
   av_codec_get_codec_descriptor : Tav_codec_get_codec_descriptor = Nil;
   av_codec_set_codec_descriptor : Tav_codec_set_codec_descriptor = Nil;
   av_codec_get_codec_properties : Tav_codec_get_codec_properties = Nil;
   av_codec_get_lowres : Tav_codec_get_lowres = Nil;
   av_codec_set_lowres : Tav_codec_set_lowres = Nil;
   av_codec_get_seek_preroll : Tav_codec_get_seek_preroll = Nil;
   av_codec_set_seek_preroll : Tav_codec_set_seek_preroll = Nil;
   av_codec_get_chroma_intra_matrix : Tav_codec_get_chroma_intra_matrix = Nil;
   av_codec_set_chroma_intra_matrix : Tav_codec_set_chroma_intra_matrix = Nil;
   av_codec_get_max_lowres : Tav_codec_get_max_lowres = Nil;
   avcodec_get_hw_config : Tavcodec_get_hw_config = Nil;
   av_codec_iterate : Tav_codec_iterate = Nil;
   av_codec_next : Tav_codec_next = Nil;
   avcodec_version : Tavcodec_version = Nil;
   avcodec_configuration : Tavcodec_configuration = Nil;
   avcodec_license : Tavcodec_license = Nil;
   avcodec_register : Tavcodec_register = Nil;
   avcodec_register_all : Tavcodec_register_all = Nil;
   avcodec_alloc_context3 : Tavcodec_alloc_context3 = Nil;
   avcodec_free_context : Tavcodec_free_context = Nil;
   avcodec_get_context_defaults3 : Tavcodec_get_context_defaults3 = Nil;
   avcodec_get_class : Tavcodec_get_class = Nil;
   avcodec_get_frame_class : Tavcodec_get_frame_class = Nil;
   avcodec_get_subtitle_rect_class : Tavcodec_get_subtitle_rect_class = Nil;
   avcodec_copy_context : Tavcodec_copy_context = Nil;
   avcodec_parameters_alloc : Tavcodec_parameters_alloc = Nil;
   avcodec_parameters_free : Tavcodec_parameters_free = Nil;
   avcodec_parameters_copy : Tavcodec_parameters_copy = Nil;
   avcodec_parameters_from_context : Tavcodec_parameters_from_context = Nil;
   avcodec_parameters_to_context : Tavcodec_parameters_to_context = Nil;
   avcodec_open2 : Tavcodec_open2 = Nil;
   avcodec_close : Tavcodec_close = Nil;
   avsubtitle_free : Tavsubtitle_free = Nil;
   av_packet_alloc : Tav_packet_alloc = Nil;
   av_packet_clone : Tav_packet_clone = Nil;
   av_packet_free : Tav_packet_free = Nil;
   av_init_packet : Tav_init_packet = Nil;
   av_new_packet : Tav_new_packet = Nil;
   av_shrink_packet : Tav_shrink_packet = Nil;
   av_grow_packet : Tav_grow_packet = Nil;
   av_packet_from_data : Tav_packet_from_data = Nil;
   av_dup_packet : Tav_dup_packet = Nil;
   av_copy_packet : Tav_copy_packet = Nil;
   av_copy_packet_side_data : Tav_copy_packet_side_data = Nil;
   av_free_packet : Tav_free_packet = Nil;
   av_packet_new_side_data : Tav_packet_new_side_data = Nil;
   av_packet_add_side_data : Tav_packet_add_side_data = Nil;
   av_packet_shrink_side_data : Tav_packet_shrink_side_data = Nil;
   av_packet_get_side_data : Tav_packet_get_side_data = Nil;
   av_packet_merge_side_data : Tav_packet_merge_side_data = Nil;
   av_packet_split_side_data : Tav_packet_split_side_data = Nil;
   av_packet_side_data_name : Tav_packet_side_data_name = Nil;
   av_packet_pack_dictionary : Tav_packet_pack_dictionary = Nil;
   av_packet_unpack_dictionary : Tav_packet_unpack_dictionary = Nil;
   av_packet_free_side_data : Tav_packet_free_side_data = Nil;
   av_packet_ref : Tav_packet_ref = Nil;
   av_packet_unref : Tav_packet_unref = Nil;
   av_packet_move_ref : Tav_packet_move_ref = Nil;
   av_packet_copy_props : Tav_packet_copy_props = Nil;
   av_packet_make_refcounted : Tav_packet_make_refcounted = Nil;
   av_packet_make_writable : Tav_packet_make_writable = Nil;
   av_packet_rescale_ts : Tav_packet_rescale_ts = Nil;
   avcodec_find_decoder : Tavcodec_find_decoder = Nil;
   avcodec_find_decoder_by_name : Tavcodec_find_decoder_by_name = Nil;
   avcodec_default_get_buffer2 : Tavcodec_default_get_buffer2 = Nil;
   avcodec_align_dimensions : Tavcodec_align_dimensions = Nil;
   avcodec_align_dimensions2 : Tavcodec_align_dimensions2 = Nil;
   avcodec_enum_to_chroma_pos : Tavcodec_enum_to_chroma_pos = Nil;
   avcodec_chroma_pos_to_enum : Tavcodec_chroma_pos_to_enum = Nil;
   avcodec_decode_audio4 : Tavcodec_decode_audio4 = Nil;
   avcodec_decode_video2 : Tavcodec_decode_video2 = Nil;
   avcodec_decode_subtitle2 : Tavcodec_decode_subtitle2 = Nil;
   avcodec_send_packet : Tavcodec_send_packet = Nil;
   avcodec_receive_frame : Tavcodec_receive_frame = Nil;
   avcodec_send_frame : Tavcodec_send_frame = Nil;
   avcodec_receive_packet : Tavcodec_receive_packet = Nil;
   avcodec_get_hw_frames_parameters : Tavcodec_get_hw_frames_parameters = Nil;
   av_parser_iterate : Tav_parser_iterate = Nil;
   av_parser_next : Tav_parser_next = Nil;
   av_register_codec_parser : Tav_register_codec_parser = Nil;
   av_parser_init : Tav_parser_init = Nil;
   av_parser_parse2 : Tav_parser_parse2 = Nil;
   av_parser_change : Tav_parser_change = Nil;
   av_parser_close : Tav_parser_close = Nil;
   avcodec_find_encoder : Tavcodec_find_encoder = Nil;
   avcodec_find_encoder_by_name : Tavcodec_find_encoder_by_name = Nil;
   avcodec_encode_audio2 : Tavcodec_encode_audio2 = Nil;
   avcodec_encode_video2 : Tavcodec_encode_video2 = Nil;
   avcodec_encode_subtitle : Tavcodec_encode_subtitle = Nil;
   avpicture_alloc : Tavpicture_alloc = Nil;
   avpicture_free : Tavpicture_free = Nil;
   avpicture_fill : Tavpicture_fill = Nil;
   avpicture_layout : Tavpicture_layout = Nil;
   avpicture_get_size : Tavpicture_get_size = Nil;
   av_picture_copy : Tav_picture_copy = Nil;
   av_picture_crop : Tav_picture_crop = Nil;
   av_picture_pad : Tav_picture_pad = Nil;
   avcodec_get_chroma_sub_sample : Tavcodec_get_chroma_sub_sample = Nil;
   avcodec_pix_fmt_to_codec_tag : Tavcodec_pix_fmt_to_codec_tag = Nil;
   avcodec_get_pix_fmt_loss : Tavcodec_get_pix_fmt_loss = Nil;
   avcodec_find_best_pix_fmt_of_list : Tavcodec_find_best_pix_fmt_of_list = Nil;
   avcodec_find_best_pix_fmt_of_2 : Tavcodec_find_best_pix_fmt_of_2 = Nil;
   avcodec_find_best_pix_fmt2 : Tavcodec_find_best_pix_fmt2 = Nil;
   avcodec_default_get_format : Tavcodec_default_get_format = Nil;
   av_get_codec_tag_string : Tav_get_codec_tag_string = Nil;
   avcodec_string : Tavcodec_string = Nil;
   av_get_profile_name : Tav_get_profile_name = Nil;
   avcodec_profile_name : Tavcodec_profile_name = Nil;
   avcodec_default_execute : Tavcodec_default_execute = Nil;
   avcodec_default_execute2 : Tavcodec_default_execute2 = Nil;
   avcodec_fill_audio_frame : Tavcodec_fill_audio_frame = Nil;
   avcodec_flush_buffers : Tavcodec_flush_buffers = Nil;
   av_get_bits_per_sample : Tav_get_bits_per_sample = Nil;
   av_get_pcm_codec : Tav_get_pcm_codec = Nil;
   av_get_exact_bits_per_sample : Tav_get_exact_bits_per_sample = Nil;
   av_get_audio_frame_duration : Tav_get_audio_frame_duration = Nil;
   av_get_audio_frame_duration2 : Tav_get_audio_frame_duration2 = Nil;
   av_register_bitstream_filter : Tav_register_bitstream_filter = Nil;
   av_bitstream_filter_init : Tav_bitstream_filter_init = Nil;
   av_bitstream_filter_filter : Tav_bitstream_filter_filter = Nil;
   av_bitstream_filter_close : Tav_bitstream_filter_close = Nil;
   av_bitstream_filter_next : Tav_bitstream_filter_next = Nil;
   av_bsf_get_by_name : Tav_bsf_get_by_name = Nil;
   av_bsf_iterate : Tav_bsf_iterate = Nil;
   av_bsf_next : Tav_bsf_next = Nil;
   av_bsf_alloc : Tav_bsf_alloc = Nil;
   av_bsf_init : Tav_bsf_init = Nil;
   av_bsf_send_packet : Tav_bsf_send_packet = Nil;
   av_bsf_receive_packet : Tav_bsf_receive_packet = Nil;
   av_bsf_flush : Tav_bsf_flush = Nil;
   av_bsf_free : Tav_bsf_free = Nil;
   av_bsf_get_class : Tav_bsf_get_class = Nil;
   av_bsf_list_alloc : Tav_bsf_list_alloc = Nil;
   av_bsf_list_free : Tav_bsf_list_free = Nil;
   av_bsf_list_append : Tav_bsf_list_append = Nil;
   av_bsf_list_append2 : Tav_bsf_list_append2 = Nil;
   av_bsf_list_finalize : Tav_bsf_list_finalize = Nil;
   av_bsf_list_parse_str : Tav_bsf_list_parse_str = Nil;
   av_bsf_get_null_filter : Tav_bsf_get_null_filter = Nil;
   av_fast_padded_malloc : Tav_fast_padded_malloc = Nil;
   av_fast_padded_mallocz : Tav_fast_padded_mallocz = Nil;
   av_xiphlacing : Tav_xiphlacing = Nil;
   av_register_hwaccel : Tav_register_hwaccel = Nil;
   av_hwaccel_next : Tav_hwaccel_next = Nil;
   av_lockmgr_register : Tav_lockmgr_register = Nil;
   avcodec_get_type : Tavcodec_get_type = Nil;
   avcodec_get_name : Tavcodec_get_name = Nil;
   avcodec_is_open : Tavcodec_is_open = Nil;
   av_codec_is_encoder : Tav_codec_is_encoder = Nil;
   av_codec_is_decoder : Tav_codec_is_decoder = Nil;
   avcodec_descriptor_get : Tavcodec_descriptor_get = Nil;
   avcodec_descriptor_next : Tavcodec_descriptor_next = Nil;
   avcodec_descriptor_get_by_name : Tavcodec_descriptor_get_by_name = Nil;
   av_cpb_properties_alloc : Tav_cpb_properties_alloc = Nil;
   av_ac3_parse_header : Tav_ac3_parse_header = Nil;
   av_adts_header_parse : Tav_adts_header_parse = Nil;
   av_jni_set_java_vm : Tav_jni_set_java_vm = Nil;
   av_jni_get_java_vm : Tav_jni_get_java_vm = Nil;
   av_vorbis_parse_init : Tav_vorbis_parse_init = Nil;
   av_vorbis_parse_free : Tav_vorbis_parse_free = Nil;
   av_vorbis_parse_frame_flags : Tav_vorbis_parse_frame_flags = Nil;
   av_vorbis_parse_frame : Tav_vorbis_parse_frame = Nil;
   av_vorbis_parse_reset : Tav_vorbis_parse_reset = Nil;
   avcodec_dct_alloc : Tavcodec_dct_alloc = Nil;
   avcodec_dct_init : Tavcodec_dct_init = Nil;
   avcodec_dct_get_class : Tavcodec_dct_get_class = Nil;
   av_mediacodec_alloc_context : Tav_mediacodec_alloc_context = Nil;
   av_mediacodec_default_init : Tav_mediacodec_default_init = Nil;
   av_mediacodec_default_free : Tav_mediacodec_default_free = Nil;
   av_mediacodec_release_buffer : Tav_mediacodec_release_buffer = Nil;
   av_mediacodec_render_buffer_at_time : Tav_mediacodec_render_buffer_at_time = Nil;
   av_fft_init : Tav_fft_init = Nil;
   av_fft_permute : Tav_fft_permute = Nil;
   av_fft_calc : Tav_fft_calc = Nil;
   av_fft_end : Tav_fft_end = Nil;
   av_mdct_init : Tav_mdct_init = Nil;
   av_imdct_calc : Tav_imdct_calc = Nil;
   av_imdct_half : Tav_imdct_half = Nil;
   av_mdct_calc : Tav_mdct_calc = Nil;
   av_mdct_end : Tav_mdct_end = Nil;
   av_rdft_init : Tav_rdft_init = Nil;
   av_rdft_calc : Tav_rdft_calc = Nil;
   av_rdft_end : Tav_rdft_end = Nil;
   av_dct_init : Tav_dct_init = Nil;
   av_dct_calc : Tav_dct_calc = Nil;
   av_dct_end : Tav_dct_end = Nil;
   av_dv_frame_profile : Tav_dv_frame_profile = Nil;
   av_dv_codec_profile : Tav_dv_codec_profile = Nil;
   av_dv_codec_profile2 : Tav_dv_codec_profile2 = Nil;
   av_dirac_parse_sequence_header : Tav_dirac_parse_sequence_header = Nil;  
   avcodec_default_get_encode_buffer : Tavcodec_default_get_encode_buffer = Nil;      
   av_qsv_alloc_context : Tav_qsv_alloc_context = Nil;

//-------------------------------------------------


Function  libavcodec_Load(Const aLibName: String = avcodecLibName): Boolean;
Procedure libavcodec_Free;
Function  libavcodec_IsLoaded: boolean;

//==============================================================
//==============================================================
implementation

Const
   InvalidLibHandle = 0;

var
  avcodec_Handle: TLibHandle;

function libavcodec_IsLoaded: boolean;
begin
  Result := (avcodec_Handle <> InvalidLibHandle);
end;

Procedure libavcodec_Free;
begin
  if libavcodec_IsLoaded then
  begin
    DynLibs.UnloadLibrary(avcodec_Handle);
    avcodec_Handle := InvalidLibHandle;
  end;
end;

function libavcodec_Load(Const aLibName: String = avcodecLibName): Boolean;
//.............................
   Function _GetProcAddress(Const aProcName: String): {$IFDEF cpui8086}FarPointer{$ELSE}Pointer{$ENDIF};
   Begin
      result := Nil;
      If aProcName = '' Then
         exit;

      result := dynlibs.GetProcedureAddress(avcodec_Handle, AnsiString(aProcName));
   End;
   //.....................................
var
  thelib: string;

{$IF DEFINED(UNIX) and (NOT DEFINED(DARWIN))}
  ssl:Integer;
  ssp:Integer;
{$ENDIF}
begin
  Result := False;

  if avcodec_Handle <> InvalidLibHandle then Exit(True);

  if aLibName = '' then
     thelib := avcodecLibName else
     thelib := aLibName;

  avcodec_Handle := dynlibs.LoadLibrary(thelib);

   //.....................................
   // On UNIX If Library NOT load, try to load .so file
  {$IF DEFINED(UNIX) and (NOT DEFINED(DARWIN))}
   If avcodec_Handle = 0 Then
   Begin
      ssl := length(thelib);
      ssp := Pos('.so.', thelib);
      If ssp > 0 Then
         delete(thelib, ssp, ssl - ssp + 1);

      avcodec_Handle := dynlibs.LoadLibrary(thelib + '.so');
   End;
  {$ENDIF}

    if avcodec_Handle = InvalidLibHandle then Exit(False);

    //.........................................

    Pointer(av_codec_get_pkt_timebase) := _GetProcAddress('av_codec_get_pkt_timebase');
    Pointer(av_codec_set_pkt_timebase) := _GetProcAddress('av_codec_set_pkt_timebase');
    Pointer(av_codec_get_codec_descriptor) := _GetProcAddress('av_codec_get_codec_descriptor');
    Pointer(av_codec_set_codec_descriptor) := _GetProcAddress('av_codec_set_codec_descriptor');
    Pointer(av_codec_get_codec_properties) := _GetProcAddress('av_codec_get_codec_properties');
    Pointer(av_codec_get_lowres) := _GetProcAddress('av_codec_get_lowres');
    Pointer(av_codec_set_lowres) := _GetProcAddress('av_codec_set_lowres');
    Pointer(av_codec_get_seek_preroll) := _GetProcAddress('av_codec_get_seek_preroll');
    Pointer(av_codec_set_seek_preroll) := _GetProcAddress('av_codec_set_seek_preroll');
    Pointer(av_codec_get_chroma_intra_matrix) := _GetProcAddress('av_codec_get_chroma_intra_matrix');
    Pointer(av_codec_set_chroma_intra_matrix) := _GetProcAddress('av_codec_set_chroma_intra_matrix');
    Pointer(av_codec_get_max_lowres) := _GetProcAddress('av_codec_get_max_lowres');
    Pointer(avcodec_get_hw_config) := _GetProcAddress('avcodec_get_hw_config');
    Pointer(av_codec_iterate) := _GetProcAddress('av_codec_iterate');
    Pointer(av_codec_next) := _GetProcAddress('av_codec_next');
    Pointer(avcodec_version) := _GetProcAddress('avcodec_version');
    Pointer(avcodec_configuration) := _GetProcAddress('avcodec_configuration');
    Pointer(avcodec_license) := _GetProcAddress('avcodec_license');
    Pointer(avcodec_register) := _GetProcAddress('avcodec_register');
    Pointer(avcodec_register_all) := _GetProcAddress('avcodec_register_all');
    Pointer(avcodec_alloc_context3) := _GetProcAddress('avcodec_alloc_context3');
    Pointer(avcodec_free_context) := _GetProcAddress('avcodec_free_context');
    Pointer(avcodec_get_context_defaults3) := _GetProcAddress('avcodec_get_context_defaults3');
    Pointer(avcodec_get_class) := _GetProcAddress('avcodec_get_class');
    Pointer(avcodec_get_frame_class) := _GetProcAddress('avcodec_get_frame_class');
    Pointer(avcodec_get_subtitle_rect_class) := _GetProcAddress('avcodec_get_subtitle_rect_class');
    Pointer(avcodec_copy_context) := _GetProcAddress('avcodec_copy_context');
    Pointer(avcodec_parameters_alloc) := _GetProcAddress('avcodec_parameters_alloc');
    Pointer(avcodec_parameters_free) := _GetProcAddress('avcodec_parameters_free');
    Pointer(avcodec_parameters_copy) := _GetProcAddress('avcodec_parameters_copy');
    Pointer(avcodec_parameters_from_context) := _GetProcAddress('avcodec_parameters_from_context');
    Pointer(avcodec_parameters_to_context) := _GetProcAddress('avcodec_parameters_to_context');
    Pointer(avcodec_open2) := _GetProcAddress('avcodec_open2');
    Pointer(avcodec_close) := _GetProcAddress('avcodec_close');
    Pointer(avsubtitle_free) := _GetProcAddress('avsubtitle_free');
    Pointer(av_packet_alloc) := _GetProcAddress('av_packet_alloc');
    Pointer(av_packet_clone) := _GetProcAddress('av_packet_clone');
    Pointer(av_packet_free) := _GetProcAddress('av_packet_free');
    Pointer(av_init_packet) := _GetProcAddress('av_init_packet');
    Pointer(av_new_packet) := _GetProcAddress('av_new_packet');
    Pointer(av_shrink_packet) := _GetProcAddress('av_shrink_packet');
    Pointer(av_grow_packet) := _GetProcAddress('av_grow_packet');
    Pointer(av_packet_from_data) := _GetProcAddress('av_packet_from_data');
    Pointer(av_dup_packet) := _GetProcAddress('av_dup_packet');
    Pointer(av_copy_packet) := _GetProcAddress('av_copy_packet');
    Pointer(av_copy_packet_side_data) := _GetProcAddress('av_copy_packet_side_data');
    Pointer(av_free_packet) := _GetProcAddress('av_free_packet');
    Pointer(av_packet_new_side_data) := _GetProcAddress('av_packet_new_side_data');
    Pointer(av_packet_add_side_data) := _GetProcAddress('av_packet_add_side_data');
    Pointer(av_packet_shrink_side_data) := _GetProcAddress('av_packet_shrink_side_data');
    Pointer(av_packet_get_side_data) := _GetProcAddress('av_packet_get_side_data');
    Pointer(av_packet_merge_side_data) := _GetProcAddress('av_packet_merge_side_data');
    Pointer(av_packet_split_side_data) := _GetProcAddress('av_packet_split_side_data');
    Pointer(av_packet_side_data_name) := _GetProcAddress('av_packet_side_data_name');
    Pointer(av_packet_pack_dictionary) := _GetProcAddress('av_packet_pack_dictionary');
    Pointer(av_packet_unpack_dictionary) := _GetProcAddress('av_packet_unpack_dictionary');
    Pointer(av_packet_free_side_data) := _GetProcAddress('av_packet_free_side_data');
    Pointer(av_packet_ref) := _GetProcAddress('av_packet_ref');
    Pointer(av_packet_unref) := _GetProcAddress('av_packet_unref');
    Pointer(av_packet_move_ref) := _GetProcAddress('av_packet_move_ref');
    Pointer(av_packet_copy_props) := _GetProcAddress('av_packet_copy_props');
    Pointer(av_packet_make_refcounted) := _GetProcAddress('av_packet_make_refcounted');
    Pointer(av_packet_make_writable) := _GetProcAddress('av_packet_make_writable');
    Pointer(av_packet_rescale_ts) := _GetProcAddress('av_packet_rescale_ts');
    Pointer(avcodec_find_decoder) := _GetProcAddress('avcodec_find_decoder');
    Pointer(avcodec_find_decoder_by_name) := _GetProcAddress('avcodec_find_decoder_by_name');
    Pointer(avcodec_default_get_buffer2) := _GetProcAddress('avcodec_default_get_buffer2');
    Pointer(avcodec_align_dimensions) := _GetProcAddress('avcodec_align_dimensions');
    Pointer(avcodec_align_dimensions2) := _GetProcAddress('avcodec_align_dimensions2');
    Pointer(avcodec_enum_to_chroma_pos) := _GetProcAddress('avcodec_enum_to_chroma_pos');
    Pointer(avcodec_chroma_pos_to_enum) := _GetProcAddress('avcodec_chroma_pos_to_enum');
    Pointer(avcodec_decode_audio4) := _GetProcAddress('avcodec_decode_audio4');
    Pointer(avcodec_decode_video2) := _GetProcAddress('avcodec_decode_video2');
    Pointer(avcodec_decode_subtitle2) := _GetProcAddress('avcodec_decode_subtitle2');
    Pointer(avcodec_send_packet) := _GetProcAddress('avcodec_send_packet');
    Pointer(avcodec_receive_frame) := _GetProcAddress('avcodec_receive_frame');
    Pointer(avcodec_send_frame) := _GetProcAddress('avcodec_send_frame');
    Pointer(avcodec_receive_packet) := _GetProcAddress('avcodec_receive_packet');
    Pointer(avcodec_get_hw_frames_parameters) := _GetProcAddress('avcodec_get_hw_frames_parameters');
    Pointer(av_parser_iterate) := _GetProcAddress('av_parser_iterate');
    Pointer(av_parser_next) := _GetProcAddress('av_parser_next');
    Pointer(av_register_codec_parser) := _GetProcAddress('av_register_codec_parser');
    Pointer(av_parser_init) := _GetProcAddress('av_parser_init');
    Pointer(av_parser_parse2) := _GetProcAddress('av_parser_parse2');
    Pointer(av_parser_change) := _GetProcAddress('av_parser_change');
    Pointer(av_parser_close) := _GetProcAddress('av_parser_close');
    Pointer(avcodec_find_encoder) := _GetProcAddress('avcodec_find_encoder');
    Pointer(avcodec_find_encoder_by_name) := _GetProcAddress('avcodec_find_encoder_by_name');
    Pointer(avcodec_encode_audio2) := _GetProcAddress('avcodec_encode_audio2');
    Pointer(avcodec_encode_video2) := _GetProcAddress('avcodec_encode_video2');
    Pointer(avcodec_encode_subtitle) := _GetProcAddress('avcodec_encode_subtitle');
    Pointer(avpicture_alloc) := _GetProcAddress('avpicture_alloc');
    Pointer(avpicture_free) := _GetProcAddress('avpicture_free');
    Pointer(avpicture_fill) := _GetProcAddress('avpicture_fill');
    Pointer(avpicture_layout) := _GetProcAddress('avpicture_layout');
    Pointer(avpicture_get_size) := _GetProcAddress('avpicture_get_size');
    Pointer(av_picture_copy) := _GetProcAddress('av_picture_copy');
    Pointer(av_picture_crop) := _GetProcAddress('av_picture_crop');
    Pointer(av_picture_pad) := _GetProcAddress('av_picture_pad');
    Pointer(avcodec_get_chroma_sub_sample) := _GetProcAddress('avcodec_get_chroma_sub_sample');
    Pointer(avcodec_pix_fmt_to_codec_tag) := _GetProcAddress('avcodec_pix_fmt_to_codec_tag');
    Pointer(avcodec_get_pix_fmt_loss) := _GetProcAddress('avcodec_get_pix_fmt_loss');
    Pointer(avcodec_find_best_pix_fmt_of_list) := _GetProcAddress('avcodec_find_best_pix_fmt_of_list');
    Pointer(avcodec_find_best_pix_fmt_of_2) := _GetProcAddress('avcodec_find_best_pix_fmt_of_2');
    Pointer(avcodec_find_best_pix_fmt2) := _GetProcAddress('avcodec_find_best_pix_fmt2');
    Pointer(avcodec_default_get_format) := _GetProcAddress('avcodec_default_get_format');
    Pointer(av_get_codec_tag_string) := _GetProcAddress('av_get_codec_tag_string');
    Pointer(avcodec_string) := _GetProcAddress('avcodec_string');
    Pointer(av_get_profile_name) := _GetProcAddress('av_get_profile_name');
    Pointer(avcodec_profile_name) := _GetProcAddress('avcodec_profile_name');
    Pointer(avcodec_default_execute) := _GetProcAddress('avcodec_default_execute');
    Pointer(avcodec_default_execute2) := _GetProcAddress('avcodec_default_execute2');
    Pointer(avcodec_fill_audio_frame) := _GetProcAddress('avcodec_fill_audio_frame');
    Pointer(avcodec_flush_buffers) := _GetProcAddress('avcodec_flush_buffers');
    Pointer(av_get_bits_per_sample) := _GetProcAddress('av_get_bits_per_sample');
    Pointer(av_get_pcm_codec) := _GetProcAddress('av_get_pcm_codec');
    Pointer(av_get_exact_bits_per_sample) := _GetProcAddress('av_get_exact_bits_per_sample');
    Pointer(av_get_audio_frame_duration) := _GetProcAddress('av_get_audio_frame_duration');
    Pointer(av_get_audio_frame_duration2) := _GetProcAddress('av_get_audio_frame_duration2');
    Pointer(av_register_bitstream_filter) := _GetProcAddress('av_register_bitstream_filter');
    Pointer(av_bitstream_filter_init) := _GetProcAddress('av_bitstream_filter_init');
    Pointer(av_bitstream_filter_filter) := _GetProcAddress('av_bitstream_filter_filter');
    Pointer(av_bitstream_filter_close) := _GetProcAddress('av_bitstream_filter_close');
    Pointer(av_bitstream_filter_next) := _GetProcAddress('av_bitstream_filter_next');
    Pointer(av_bsf_get_by_name) := _GetProcAddress('av_bsf_get_by_name');
    Pointer(av_bsf_iterate) := _GetProcAddress('av_bsf_iterate');
    Pointer(av_bsf_next) := _GetProcAddress('av_bsf_next');
    Pointer(av_bsf_alloc) := _GetProcAddress('av_bsf_alloc');
    Pointer(av_bsf_init) := _GetProcAddress('av_bsf_init');
    Pointer(av_bsf_send_packet) := _GetProcAddress('av_bsf_send_packet');
    Pointer(av_bsf_receive_packet) := _GetProcAddress('av_bsf_receive_packet');
    Pointer(av_bsf_flush) := _GetProcAddress('av_bsf_flush');
    Pointer(av_bsf_free) := _GetProcAddress('av_bsf_free');
    Pointer(av_bsf_get_class) := _GetProcAddress('av_bsf_get_class');
    Pointer(av_bsf_list_alloc) := _GetProcAddress('av_bsf_list_alloc');
    Pointer(av_bsf_list_free) := _GetProcAddress('av_bsf_list_free');
    Pointer(av_bsf_list_append) := _GetProcAddress('av_bsf_list_append');
    Pointer(av_bsf_list_append2) := _GetProcAddress('av_bsf_list_append2');
    Pointer(av_bsf_list_finalize) := _GetProcAddress('av_bsf_list_finalize');
    Pointer(av_bsf_list_parse_str) := _GetProcAddress('av_bsf_list_parse_str');
    Pointer(av_bsf_get_null_filter) := _GetProcAddress('av_bsf_get_null_filter');
    Pointer(av_fast_padded_malloc) := _GetProcAddress('av_fast_padded_malloc');
    Pointer(av_fast_padded_mallocz) := _GetProcAddress('av_fast_padded_mallocz');
    Pointer(av_xiphlacing) := _GetProcAddress('av_xiphlacing');
    Pointer(av_register_hwaccel) := _GetProcAddress('av_register_hwaccel');
    Pointer(av_hwaccel_next) := _GetProcAddress('av_hwaccel_next');
    Pointer(av_lockmgr_register) := _GetProcAddress('av_lockmgr_register');
    Pointer(avcodec_get_type) := _GetProcAddress('avcodec_get_type');
    Pointer(avcodec_get_name) := _GetProcAddress('avcodec_get_name');
    Pointer(avcodec_is_open) := _GetProcAddress('avcodec_is_open');
    Pointer(av_codec_is_encoder) := _GetProcAddress('av_codec_is_encoder');
    Pointer(av_codec_is_decoder) := _GetProcAddress('av_codec_is_decoder');
    Pointer(avcodec_descriptor_get) := _GetProcAddress('avcodec_descriptor_get');
    Pointer(avcodec_descriptor_next) := _GetProcAddress('avcodec_descriptor_next');
    Pointer(avcodec_descriptor_get_by_name) := _GetProcAddress('avcodec_descriptor_get_by_name');
    Pointer(av_cpb_properties_alloc) := _GetProcAddress('av_cpb_properties_alloc');
    Pointer(av_ac3_parse_header) := _GetProcAddress('av_ac3_parse_header');
    Pointer(av_adts_header_parse) := _GetProcAddress('av_adts_header_parse');
    Pointer(av_jni_set_java_vm) := _GetProcAddress('av_jni_set_java_vm');
    Pointer(av_jni_get_java_vm) := _GetProcAddress('av_jni_get_java_vm');
    Pointer(av_vorbis_parse_init) := _GetProcAddress('av_vorbis_parse_init');
    Pointer(av_vorbis_parse_free) := _GetProcAddress('av_vorbis_parse_free');
    Pointer(av_vorbis_parse_frame_flags) := _GetProcAddress('av_vorbis_parse_frame_flags');
    Pointer(av_vorbis_parse_frame) := _GetProcAddress('av_vorbis_parse_frame');
    Pointer(av_vorbis_parse_reset) := _GetProcAddress('av_vorbis_parse_reset');
    Pointer(avcodec_dct_alloc) := _GetProcAddress('avcodec_dct_alloc');
    Pointer(avcodec_dct_init) := _GetProcAddress('avcodec_dct_init');
    Pointer(avcodec_dct_get_class) := _GetProcAddress('avcodec_dct_get_class');
    Pointer(av_mediacodec_alloc_context) := _GetProcAddress('av_mediacodec_alloc_context');
    Pointer(av_mediacodec_default_init) := _GetProcAddress('av_mediacodec_default_init');
    Pointer(av_mediacodec_default_free) := _GetProcAddress('av_mediacodec_default_free');
    Pointer(av_mediacodec_release_buffer) := _GetProcAddress('av_mediacodec_release_buffer');
    Pointer(av_mediacodec_render_buffer_at_time) := _GetProcAddress('av_mediacodec_render_buffer_at_time');
    Pointer(av_fft_init) := _GetProcAddress('av_fft_init');
    Pointer(av_fft_permute) := _GetProcAddress('av_fft_permute');
    Pointer(av_fft_calc) := _GetProcAddress('av_fft_calc');
    Pointer(av_fft_end) := _GetProcAddress('av_fft_end');
    Pointer(av_mdct_init) := _GetProcAddress('av_mdct_init');
    Pointer(av_imdct_calc) := _GetProcAddress('av_imdct_calc');
    Pointer(av_imdct_half) := _GetProcAddress('av_imdct_half');
    Pointer(av_mdct_calc) := _GetProcAddress('av_mdct_calc');
    Pointer(av_mdct_end) := _GetProcAddress('av_mdct_end');
    Pointer(av_rdft_init) := _GetProcAddress('av_rdft_init');
    Pointer(av_rdft_calc) := _GetProcAddress('av_rdft_calc');
    Pointer(av_rdft_end) := _GetProcAddress('av_rdft_end');
    Pointer(av_dct_init) := _GetProcAddress('av_dct_init');
    Pointer(av_dct_calc) := _GetProcAddress('av_dct_calc');
    Pointer(av_dct_end) := _GetProcAddress('av_dct_end');
    Pointer(av_dv_frame_profile) := _GetProcAddress('av_dv_frame_profile');
    Pointer(av_dv_codec_profile) := _GetProcAddress('av_dv_codec_profile');
    Pointer(av_dv_codec_profile2) := _GetProcAddress('av_dv_codec_profile2');     
    Pointer(av_dirac_parse_sequence_header) := _GetProcAddress('av_dirac_parse_sequence_header');  
    Pointer(avcodec_default_get_encode_buffer) := _GetProcAddress('avcodec_default_get_encode_buffer');   
    Pointer(av_qsv_alloc_context) := _GetProcAddress('av_qsv_alloc_context');

    //.........................................

    Result := True;

end;

end.
